/********************************************************
 * ZELDA::GAME.C  **********************************************
 ********************************************************/

#include "internal.h"

#define Editor
int yes_quit=0,new=0;
int PERDUVAR=0;
/*************************** run_game *******************************/
void
run_game (void)
{
  int editor = 0, edix = 0, ediy = 0, choix = 1, clayer = 0, dd, d;
  int in,y;
  counter_anim = 0;
  init_scripts ();
/* menu de bidaya */
//goto start;
ret2:
im_choix=CHOIX2;

  playmidi(MIDI17);
ret:
  {
  BITMAP *bmp;
  bmp=Data[INTRO].dat;
  Tih (buffer , bmp ,  -10 , 10, 15,100);
  textanim (buffer , sfont , "Nouvelle partie",55,150,7,9,50,0);
  textanim (buffer , sfont , "Charger",55,160,7,12,50,0);
  textanim (buffer , sfont , "Options",55,170,7,14,50,0);
  textanim (buffer , sfont , "Quitter",55,180,7,0,50,0);
  textanim (buffer , sfont , "Mehdi Cherti 2004/2005",140,190,7,1,20,0);

  in=Choix (34,147,4,10,0);
  /* quitter */
  if(in==3) exit(0);
  /* options */
  if(in == 2) {
	setup_main ();
	exit (0);
  }
  /* nouvelle partie */
  if(in == 0){
	  char *n1=0,*n2=0,*n3=0;
	  int n=0,p;
	  Tih (buffer,Data[NOUV].dat,-10,10,15,100);
	  if(exists ("save/slot1")){
		  load_game("save/slot1");
		  n1 = strdup (get_cur_save());
		  n++;
	  }
	  if(exists ("save/slot2")){
		  load_game("save/slot2");
		  n2 = strdup (get_cur_save());
		  n++;
	  }
	  if(exists ("save/slot3")){
		  load_game("save/slot3");
		  n3 = strdup (get_cur_save());
		  n++;
	  }
	  textanim(buffer,sfont,"Retour",100,100,7,10,50,0);
	  textanim (buffer,sfont,"Ficher 1:",100,120,7,12,50,0);
	  textanim (buffer,sfont,"Ficher 2:",100,140,7,12,50,0);
	  textanim (buffer,sfont,"Ficher 3:",100,160,7,12,50,0);

	  if(n >= 1) {
		  textanim (buffer,sfont,n1,180,120,7,9,50,0);
	  }
	  if(n >= 2) {
		  textanim (buffer,sfont,n2,180,140,7,9,50,0);
	  }
	  if(n >= 3) {
		  textanim (buffer,sfont,n3,180,160,7,9,50,0);
	  }
	  if(n1) free (n1); if(n2) free(n2);if(n3) free(n3);
          p=Choix (70,100,4,20,0);
	  if(p == 0){
	
		  FADE(FADE_NORMAL);
		  set_palette(default_palette);
		  goto ret;
	  }
	  
	  {
		  char *a,ss[256];
		  clear_to_color (buffer,15);
		  textanim (buffer,sfont,"Notez votre nom:",100,50,7,12,50,0);
		  a=(char*)select_name (buffer,pp.name,100,60,0);
		  strcpy(get_cur_save(),a);
		  free (a);
		  FADE(FADE_ESCALIER_SPEED);
		  load_game("zero");
		  load_all_screen_map();
		  sprintf(ss,"save/slot%i",p);
		  save_game(ss);
		  slot_number=p;
		 pp.pvfrappe=1;
		  set_pp_epee();
		  new = 1;
		  goto start;
	  }



  }
  /* charger */
  if(in == 1){
	  char *n1=0,*n2=0,*n3=0;
	  int n=0,p;
	  Tih (buffer , Data[CHARGER].dat , -10,10,15,100);
	  if(exists ("save/slot1")){
		  load_game("save/slot1");
		  n1 = strdup (get_cur_save());
		  n++;
	  }
	  if(exists ("save/slot2")){
		  load_game("save/slot2");
		  n2 = strdup (get_cur_save());
		  n++;
	  }
	  if(exists ("save/slot3")){
		  load_game("save/slot3");
		  n3 = strdup (get_cur_save());
		  n++;
	  }
	  textanim(buffer,sfont,"Retour",100,100,7,10,50,0);
	  if(n >= 1) {
		  textanim (buffer,sfont,"Ficher 1:",100,120,7,12,50,0);
		  textanim (buffer,sfont,n1,180,120,7,9,50,0);
	  }
	  if(n >= 2) {
		  textanim (buffer,sfont,"Ficher 2:",100,140,7,12,50,0);
		  textanim (buffer,sfont,n2,180,140,7,9,50,0);
	  }
	  if(n >= 3) {
		  textanim (buffer,sfont,"Ficher 3:",100,160,7,12,50,0);
		  textanim (buffer,sfont,n3,180,160,7,9,50,0);
	  }
	  if(n1) free (n1); if(n2) free(n2);if(n3) free(n3);
          p=Choix (70,100,n+1,20,0);
	  if(p == 0){
		  FADE(FADE_NORMAL);
		  set_palette(default_palette);
		  goto ret;
	  }
	  {
		  char ss[256];
		  sprintf(ss,"save/slot%i",n);
		  load_game (ss);
		  load_all_screen_map();
		  slot_number=n;
		  FADE(FADE_ESCALIER_SPEED);
		  Map.place=set_place(Map.stage);
		  goto start;
	  }


		  
  }
  
  }
start:
	      
  setpal;
  im_choix=CHOIX;
 if(new){
	 new=0;
	 clear_bitmap(buffer);
	 pres_text("une Femme avait eu un enfant handicape..");
	 pres_text("Elle l'eduqua pendant de longues annees...");
	 pres_text("mais elle n'avait guere les moyens de le");
	 pres_text("faire vivre,elle decida de le laisser");
	 pres_text("a le rue et partir...c'etait le seule");
	 pres_text("solution...alors qu'il avait 10 ans deja");
	 pres_text("Azzi avait un sale caractere...Il");
	 pres_text("jura de faire payer tout cela a");
	 pres_text("tout le monde...Bien qu'il etait");
	 pres_text("handicape , il avait obtenu avec");
	 pres_text("le temps,d'etranges pouvoirs...");
	 pres_text("Azzi decida de maudir sa mere et");
	 pres_text("il en plus il a promis qu'il en");
	 pres_text("ferait de plus a tout le monde");
	 pres_text("qui etait autour de lui...il avait");
	 pres_text("aquerit une enorme force...inconnue");
	 pres_text("Sa mere s'etait marie avec un homme");
	 pres_text("riche mais elle n'avait jamais");
	 pres_text("oublie Azzi ,la mere eut un");
	 pres_text("enfant qui s'appelait Izza");
	 pres_text("une jeune garcon tres courageux");
	 pres_text("et tres fort , C'etait le seul");
	 pres_text("qui pouvait sauver sa mere");
	 pres_text("mais Helas ca ne sera pas");
	 pres_text("facile...");
	 pres_text("Il devra surmonter beaucoup");
	 pres_text("d'epreuves pour parvenir a");
	 pres_text("detruire Azzi...");
	 FADE (FADE_ESCALIER_SPEED); 
          play_place_midi (Map.place);  /* joue le midi de la place actuelle */
	  affiche(buffer);
	  parle (pp.name,"Ouf..Je dois aller chez mon pere dans cette maison",NULL,NULL);
  }
 else   play_place_midi (Map.place);  /* joue le midi de la place actuelle */

 
  while (!key[KEY_ESC])
    {
      poll_keyboard (); /* mise a jour du clavier */
	  poll_joystick();  /* mise a jour du Joystick */
      ANIMATION ();     /* faire l'animation memoire des persos,monstres..*/
	  if(PERDUVAR){
		  PERDUVAR=0;
		  FADE(FADE_NORMAL);
		  set_palette(default_palette);
		  goto ret2;
	  }


      if (BTENTER && !editor) {/* menu */
	  menu ();
	  if(yes_quit){
		  yes_quit=0;
		  FADE(FADE_NORMAL);
		  set_palette(default_palette);
		  goto ret2;
	  }
      }


/*************** pour faire marcher le personnage ***********************/
      dd = 0;
if((counter_anim >= ANIM_DELAY )){ /* delay avant de marcher*/
	int a=pp.dir;
      if(pp.zleq){
	      dd=1;
	      marcher(pp.dir);
	      goto fi;
      }
      if (BTUP){ /* haut */
	  dd = 1;
	  pp.dir = 2;
	  marcher (2);
	  pp.anim[2]++;
	}
	  
    if (BTDOWN){ /* bas */
	  dd = 1;
	  pp.dir = 3;
	  marcher (3);
	  pp.anim[3]++;
	}
	
    if (BTLEFT){ /* gauche */
	  dd = 1;
	  pp.dir = 1;
	  marcher (1);
	  pp.anim[1]++;
	}
      if (BTRIGHT){ /* droite */
	  dd = 1;
	  pp.dir = 0;
	  marcher (0);
	  pp.anim[0]++;
	}
}
fi:
if (dd) counter_anim=0; /* reset du compteur */


    if (pp.anim[pp.dir] >= 3){ /* reset dans l'animation du PP */
	  pp.anim[pp.dir] = 0;
	  counter_anim = 0;
	}
/**********************************************************************/
      if (BTACTION_A) /* premier item */
	use_item (0);
      if (BTACTION_B) /* deuxieme item */
	use_item (1);

 /*********** editor *********/
#ifdef Editor
	
      if (key[KEY_E])
	editor = 1;
      if (key[KEY_R])
	editor = 0;
	clear_bitmap(buffer);
      affiche (buffer);
	if(key[KEY_G]) {
		save_bitmap("sc/screen_shot.bmp",buffer,Data[PAL].dat);
	}
      if (editor)
	{
	  if (key[KEY_T])
	    {
	      Map.stage = 0;
	      load_all_screen_map ();
	    }
	  if (key[KEY_I])
	    {
	      Map.stage++;
	      load_all_screen_map ();
	      rest (100);
	    }
	  if (key[KEY_O])
	    {
	      Map.stage--;
	      load_all_screen_map ();
	      rest (100);
	    }
	  if (key[KEY_K])
	    {
	      Map.stage -= 4;
	      load_all_screen_map ();
	      rest (100);
	    }
	  if (key[KEY_L])
	    {
	      Map.stage += 4;
	      load_all_screen_map ();
	      rest (100);
	    }

	  if (key[KEY_1])
	    clayer = 0;
	  if (key[KEY_2])
	    clayer = 1;
	  if (key[KEY_3])
	    clayer = 2;
	  if (key[KEY_N])
	    save_map (Map, worldmap);

	  if (key[KEY_P])
	    {
	      d = 0;

	      for (d = 0; d < 160; d++)
		{
		  Map.obs[clayer][(Map.stage * Map.w * Map.h) + d] = choix;
		}

	      load_all_screen_map ();
	    }
	  if (key[KEY_END])
	    {
	      for (d = 0; d < Map.maxim; d++)
		{
		  if (Map.images[d] == -1)
		    {
		      choix = d - 1;
		      break;
		    }
		}
	    }
	  if (key[KEY_HOME])
	    choix = 1;
	  if (key[KEY_D] && Map.images[choix + 1] != -1)
	    {
	      choix++;
	      rest (100);
	    }
	  if (key[KEY_F] && choix - 1 >= 1)
	    {
	      choix--;
	      rest (100);
	    }
	  if (key[KEY_6_PAD])
	    {
	      edix++;
	      rest (100);
	    }
	  if (key[KEY_4_PAD])
	    {
	      edix--;
	      rest (100);
	    }
	  if (key[KEY_8_PAD])
	    {
	      ediy--;
	      rest (100);
	    }
	  if (key[KEY_2_PAD])
	    {
	      ediy++;
	      rest (100);
	    }
	  if (key[KEY_X])
	    choix =
	      Map.obs[clayer][(Map.stage * Map.w * Map.h) + edix + ediy * 16];
	  rect (buffer, edix * 20, ediy * 20, edix * 20 + 20, ediy * 20 + 20,
		15);
	  stretch_sprite (buffer, Data[Map.images[choix]].dat, edix * 20,
			  ediy * 20, 10, 10);
	  if (key[KEY_ENTER])
	    {
	      Map.obs[clayer][(Map.stage * Map.w * Map.h) + edix +
			      ediy * 16] = choix;
	      load_all_screen_map ();
	    }
	  textprintf (buffer, font, 0, 190, 7, "%i,%i,%i", Map.stage, edix,
		      ediy);

	}
#endif
/*****************************************************************/
      blit (buffer, screen, 0, 0, 0, 0,SCREEN_W, SCREEN_H);
    }

}
