/********************************************************
 * ZELDA::PLAYER.C  **********************************************
 ********************************************************/

#include "internal.h"
#include "pmask.h"
#define set_pp_image(n,v) pp.images[n]=v;
int  teleport_stage=34,teleport_x=8*20,teleport_y=5*20;

/* interrupteurs */
int int_bool[20]={0};
int *int_bool_get () {return int_bool;}
/******************/

int show_bulle = (-1); /* la bulle de (!) ou (?) */

int PPSURF = 0;
int surf_voice=-1;

const char *ret_place_name (int p){
	switch(p){
		case 9 : return "Donjon 3 : la grotte aquatique";
		case 7 : return "Donjon 2 : le cimetiere";
		case 8 : return "Desert du Sahara";
		case 11 : return "Afia";
		case 13 : return "Donjon 5 : la caverne glacee";
		case 12 : return "Donjon 4 : Le temple";
		case 2 : return "Aifa";
		case 3  : return "Donjon 1 : la Grotte glacee";
		case 6 : return "Foret Noire";
		case 14 : return "Shop";
	}
	return NULL;

}
void show_title (BITMAP *b){
	const char *place=ret_place_name(Map.place);
	if(place){
	FONT *f = sfont;	
	int xlen = text_length (f,place);
	int ylen = text_height (f);
	int x = (SCREEN_W-xlen)/2 , y = (SCREEN_H-ylen)/2;
	my_textout (screen ,f , place ,x,y,7,15);
	rest (1000);
	blit (b,screen,0,0,0,0,SCREEN_W,SCREEN_H);
	}
}


DERN dern; /* dernieres valeurs X,Y,STAGE du perso avant d'entrer dans une porte*/
/*variables*/
int troc[255] = { 0 };
int max_troc = 0;

int objs [255] = {0};
int max_objs=0;
/**/


int max_trou = 0;

int BOSS = 0;
int appui = 0;

int nomarcher = 0;
int gr = 0;

int monde (){
 int ret=0;
 if( (Map.hqst != -1  && Map.hqst>=155) || (Map.hqst == -1 && Map.stage >= 155)) ret=1;
 return ret;
}
int CHRI (int argent){
	if(argent > pp.arg) parle ("argent insuffisant..",NULL,NULL,NULL);
	else {
		pp.arg-=argent;
		return 1;
	}
	return 0;
}

void buy (int item){
	switch(item){
		case O_POTION:
			
			break;
		case O_FEU :
			if(SEARCH_ITEM (I_FEU)) parle ("mais vous en avez deja !!",NULL,NULL,NULL);
			else if (CHRI (100)) ADD_ITEM (I_FEU);
			del_troc_item (search_troc_item (OBJ4));
			break;
	}
}
int is_gant(int i){
	switch(i){
		case 24 : return 1;
		case 128  : return 2;		  
	}
	return 0;
}
/* is_int */
int is_int (int i){
	switch (i) {
		case 121 : return 1;
		case 120 : return 2;
	}
	return 0;
}

int int_to_trace (int t){
	switch(t){
		case 1 : return 124;
		case 2 : return 123;	
	}
	return 0;
}
int car (int n){
	switch(n){
		case 1 : return 64;
		case 2 : return 122;	 
	}
}
int is_int_trace (int t){
	switch(t){
	case 124 : return 1;
	case 123 : return 2;	   
	}
	return 0;
}
int is_int_car (int t){
	switch(t){
		case 64 : return 1;
		case 122 : return 2;		  

	}
	return 0;
}
/* is_sphere */
int is_sphere (int s){
	switch(s){
		case 103 : return 1;
		case 105 : return 2;
	}
	return 0;

}

int is_sphere_image(int s){
	switch(s){
		case OBJ2 : return 103;
		case OBJ3 : return 105;
	}
	return 0;
}
/*set_dern*/
void
set_dern(void){
		dern.stage = Map.stage;
		dern.x   = pp.x;
		dern.y   = pp.y;
		dern.dir = pp.dir;
}
int get (int s,int c){
	return get_obs (Map , s , 0 , c);
}
#define is(s) (is_sphere(get(stage,s)))
/* test epee */
int ep=0;
int epee_test (int pcx,int pcy){
	int s=pcx+pcy*16;
	int l=Map.show[0][s];
	int a;
	if((a=is_int (l)) && !ep){
		if(!int_bool[a]) int_bool [a] = l;
		else int_bool[a]=0;
		ep=pp.jeter_epee;
		play_sfx (SFX11);
		load_all_screen_map();
	}
       if (l==10 &&& obj.en && obj.cur == I_EPEE && pp.jeter_epee)
	{
	  play_sfx (SFX12);
	  Map.show[0][s] = 1;
	  if ((rand () % 10) == 6)
	    {
	      Map.show[0][s] = 25;
	    }
	  else if (rand () % 10 == 9)
	    {
	      Map.show[0][s] = 69;

	    }

	}

}


/* boutton_action */
void
boutton_action (int stage,int pcx,int pcy){
	int t=pcx+pcy*16;
	if(stage == 142){
		int o  = get_obs (Map , stage , 0 ,calcul_obs(16,6,7));
		int o2 = get_obs (Map , stage , 0 ,calcul_obs(16,11,7));
		if((is_sphere (o) == 2 && is_sphere(o2) == 1)) {
			int cal=calcul_obs(16,2,4);
			change_obstacle (stage , 0 , cal , Map.show[1][cal]);
			load_all_screen_map ();
		}
	}
	if(stage == 98){
		int o=get_obs(Map,stage,0,calcul_obs(16,6,4));
		int o2=get_obs(Map,stage,0,calcul_obs(16,7,4));
		int o3=get_obs(Map,stage,0,calcul_obs(16,8,4));
		if(is_sphere(o)==2 && is_sphere(o2)==1 && is_sphere(o3)==1){
			int cal=calcul_obs(16,9,2);
			change_obstacle(stage,0,cal,Map.show[1][cal]);
			load_all_screen_map();
		}
	}
	else if(stage == 135){
		clear_bibane (63);
	}
	else if(stage == 148){
		int cal = calcul_obs(16,13,8);
		change_obstacle (stage,0,cal,Map.show[1][cal]);
		load_all_screen_map ();
	}
	else if(stage == 145){
		int cal = calcul_obs(16,pcx,pcy);
		change_obstacle (stage,0,cal-2,62);
		change_obstacle (stage,0,cal+2,62);
		load_all_screen_map ();
	}
	else if(stage == 146){
		int w=16;
		int c=calcul_obs(w,10,2);
		int c2=c+1;
		if( (is (c) == 1 && is(c+w) == 1  && is (c+w*2) == 1 && is((c+w*2)-1)==1 && (is((c+w*3)-1))==1 ) && 
		(is (c2) == 2 && is(c2+w) == 2  && is (c2+w*2) == 2 && is((c2+w*2)+1)==2 && is((c2+w*3)+1)==2 )){
			int d=calcul_obs(16,1,3);
			change_obstacle (stage,0,d,Map.show[1][d]);
			load_all_screen_map ();
		}

		
	}
	else if(stage == 137){
		int cal = calcul_obs(16,8,5);
		change_obstacle (stage,0,cal,Map.show[1][cal]);
		load_all_screen_map ();
	}
	else if(stage == 144){
		int o1 = is (calcul_obs (16,2,4));
		int o2 = is (calcul_obs (16,11,4));
		if(o1 == 2 && o2 == 1){
			int cal=calcul_obs(16,1,7);
			change_obstacle(stage,0,cal,Map.show[1][cal]);
			load_all_screen_map ();
		}
	}
}

/* sphere_action */
void sphere_action (int stage ,int pcx,int pcy,int type,int typeS,int im){
	int p=pcx+pcy*16;

}

int is_rocher (int im){
	switch(im){
		case 117:return 1;
		case 60:return 2;		 
		case 126:return 3;	
		case 130:return 4;	 
	}
	return 0;
}

int is_grappin (int obs){
	switch(obs){
		case 60 : return 1;
		case 34 : return 2;	
                case 132: return 3;			  
	}
	return 0;
}
int is_feu (int obs){
	switch(obs){
		case 132 : return 1;
	}
	return 0;
}
/*********************test_obj***********************/
void
test_obj (int pcx, int pcy)
{
  	
  int obs = Map.show[0][pcx + pcy * 16];
  int i, s;
  int x, y;
  if (!obj.en)
    return;
      //FEU
    if(obj.cur == I_FEU && is_feu (obs)){
		s = pcx + pcy*16;
		Map.show[0][s]=Map.show[1][s];
		play_sfx (SFX17);
     }

  //GRAPPIN
  if(obj.cur == I_GRAPPIN){
      test (pcx, pcy);
  }
  if (obj.cur == I_GRAPPIN && is_grappin (obs))
    {
     nofrappe = 1;
      obj.anim = 1;		//empecher l'animation du grappin
      if (obj.dir == 0)
	{
	  s = pp.x;
	  x = obj.x;
	  for (i = pp.x; i < x; i += GRAPPIN_VIT)
	    {
	      pp.x = i;
	      hbs ();
	      ANIMATION ();
	      obj.x = x;
	      affiche (buffer);
	      show_obj (buffer);
	      BLIT ();
	      rest (GRAPPIN_DELAY);
	    }
	}
      else if (obj.dir == 1)
	{
	  s = pp.x;
	  x = obj.x;
	  for (i = pp.x; i > x; i -= GRAPPIN_VIT)
	    {
	      pp.x = i;
	      hbs ();
	      ANIMATION ();
	      obj.x = x;
	      affiche (buffer);
	      show_obj (buffer);
	      BLIT ();
	      rest (GRAPPIN_DELAY);
	    }

	}


      else if (obj.dir == 2)
	{
	  s = pp.y;
	  x = obj.y;
	  for (i = pp.y; i > x; i -= GRAPPIN_VIT)
	    {
	      pp.y = i;
	      hbs ();
	      ANIMATION ();
	      obj.y = x;
	      affiche (buffer);
	      show_obj (buffer);
	      BLIT ();
	      rest (GRAPPIN_DELAY);
	    }

	}

      if (obj.dir == 3)
	{
	  s = pp.y;
	  x = obj.y;
	  for (i = pp.y; i < x; i += GRAPPIN_VIT)
	    {
	      pp.y = i;
	      hbs ();
	      ANIMATION ();
	      obj.y = x;
	      affiche (buffer);
	      show_obj (buffer);
	      BLIT ();
	      rest (GRAPPIN_DELAY);
	    }
	}





      obj.anim = 0;
      obj.en = 0;
      obj.cur = 0;
      nomarcher = 0;
      nofrappe = 0;
    }
}
/*direc*/

int direc(int dir) {if(dir == 0 || dir == 3) return 0; else return 1;}

/* exploser */
void explose_bombe (int x,int y,int power){
	int i,cal;
	for(i = 1  ; i < power+1;i++){
		cal=x+i+y*16;
		if(is_rocher(Map.show[0][cal])) Map.show[0][cal]=Map.show[1][cal];
		cal=x-i+y*16;
		if(is_rocher(Map.show[0][cal])) Map.show[0][cal]=Map.show[1][cal];
		cal=x+(y-i)*16;
		if(is_rocher(Map.show[0][cal])) Map.show[0][cal]=Map.show[1][cal];
		cal=x+(y+i)*16;
		if(is_rocher(Map.show[0][cal])) Map.show[0][cal]=Map.show[1][cal];
	}
}

/****************************do_obj**************************/
void
do_obj ()
{
  // FEU	
  if(obj.cur == I_FEU && obj.en){
	if(counter_bombe >= 100){
		int n=10;
		counter_bombe = 0;
		if(obj.dir == 0 ) obj.x += n;
		else if(obj.dir == 1 ) obj.x -= n;
		else if(obj.dir == 2 ) obj.y -= n;
		else if(obj.dir == 3 ) obj.y += n;
   	        obj.anim = (obj.anim + 2) % 256;
		if(obj.x >= SCREEN_W || obj.x <= 0 || obj.y >= SCREEN_H || obj.y <= 0) {
			obj.en=0;
			obj.cur=0;
		}
	      HBS (obj.x, obj.y,n, obj.dir, &obj.pc1x, &obj.pc1y, &obj.pc2x, &obj.pc2y);
		test_obj (obj.pc1x , obj.pc1y);
		test_obj (obj.pc2x , obj.pc2y);

		
	}
  }
  //BOTTES
  if (obj.cur == I_BOTTES && obj.en)
    {
      pp.vit = obj.anim * 2;
      if (counter_bottes >= 200)
	{
	  counter_bottes = 0;
	  pp.vit = obj.anim;
	  obj.en = 0;
	  obj.cur = 0;
	}
    }
  //GRAPPIN
  else if (obj.cur == I_GRAPPIN && obj.en && counter_grappin >= 20)
    {
      int f, p;
      int pc1x, pc1y, pc2x, pc2y;
      counter_grappin = 0;
      f = 0;
      p = 0;
      if (obj.dir == 0)
	{
	  obj.x += GRAPPIN_VIT;
	  f = obj.x - pp.x;
	}
      else if (obj.dir == 1)
	obj.x -= GRAPPIN_VIT;
      else if (obj.dir == 2)
	obj.y -= GRAPPIN_VIT;
      else if (obj.dir == 3)
	obj.y += GRAPPIN_VIT;
      HBS (obj.x, obj.y, GRAPPIN_VIT, obj.dir, &pc1x, &pc1y, &pc2x, &pc2y);
      if (!obj.anim)
	{
	  test_obj (pc1x, pc1y);
	  test_obj (pc2x, pc2y);
	}
      if (obj.x >= SCREEN_W || obj.x <= 0 || obj.y <= 0 || obj.y >= SCREEN_H
	  || (!obj.en && !obj.cur))
	{
	  obj.en = 0;
	  obj.cur = 0;
	  nomarcher = 0;
	}
    }
  // BOOMERANG
  else if(obj.cur == I_BOOMERANG && obj.en && counter_boom >= 100){
		  counter_boom=0;
		  if(obj.dir == 0) obj.x+=BOOM_VITESSE;
		  else if(obj.dir == 1) obj.x-=BOOM_VITESSE;
		  else if(obj.dir == 2) obj.y-=BOOM_VITESSE;
		  else if(obj.dir == 3) obj.y+=BOOM_VITESSE;
		  obj.anim = (obj.anim + BOOM_VITESSE_ANGLE) % 256;
	      if(obj.x >= SCREEN_W-20 || obj.x <= 0|| obj.y >= SCREEN_H || obj.y <= 0) {
			 obj.mode=1;
			 obj.nx = obj.x ; obj.ny = obj.y;
			 obj.dir = notdir(obj.dir);
		  }
		  
		  if(obj.mode == 1){ // le boomerang revient chez le perso
				 int px=pp.x,py=pp.y,bx=obj.nx,by=obj.ny;
				 if(obj.dir == 0 || obj.dir == 3){
					 if(px > bx  ) swapvar(&px , &bx);
					 if(py > by ) swapvar(&py , &by);
				 }
				 if(obj.dir == 1|| obj.dir == 2){
					 if(px < bx  ) swapvar(&px , &bx);
					 if(py < by ) swapvar(&py , &by);
				 }

				  if(obj.dir <= 1) {obj.y = EQUATION_DROITE_X_TO_Y(obj.x , px , py , bx , by);}
				  else obj.x = EQUATION_DROITE_Y_TO_X(obj.y , px , py , bx , by);
			
		  }
		  
  
  }

  /* BOMBE */
  else if(obj.cur == I_BOMBE && obj.en){
	  obj.anim=counter_bombe/100;
	  if(obj.anim>=2) {counter_bombe=0;obj.anim=0;play_sfx(SFX9);}
	  if(counter_bombe2 >= BOMBE_EXPLOSE_DELAY){
		  int ox,oy,cal;
		  play_sfx(SFX4);
		  Explosion (Data[EXPL0].dat,obj.x-10,obj.y-10,30);
		  obj.en=0;
		  obj.cur=-1;
		  
		  explose_bombe (obj.pc1x,obj.pc1y,1);
		  explose_bombe (obj.pc2x,obj.pc2y,1);
		  if(if_collision(Data[EXPL0].dat,Data[pp.images[0]].dat,obj.x,obj.y,pp.x,pp.y)){
			  frapper_perso (1);
		  }

		
	  }
  }
}


/**********************************show_obj******************************/
void
show_obj (BITMAP * bmp)
{
  int i, dx;
  BITMAP *s, *s2;
  // FEU
  if(obj.cur == I_FEU && obj.en){
  rotate_sprite(bmp , Data[MAGIE0].dat , obj.x , obj.y , itofix(obj.anim));	  
  }
  //BOMMERANG
  if(obj.cur == I_BOOMERANG && obj.en){
		rotate_sprite(bmp , Data[GRAPPIN1].dat , obj.x , obj.y , itofix(obj.anim));	  
  }
  //GRAPPIN
  else if (obj.cur == I_GRAPPIN && obj.en)
    {
      //a droite
      if (obj.dir == 0)
	{

	  dx = pp.x;
	  for (i = 0; i < (obj.x - pp.x) / GRAPPIN_VIT; i++)
	    {
	      dx += GRAPPIN_VIT;
	      draw_sprite (bmp, Data[GRAPPIN1].dat, dx, obj.y);
	    }
	  draw_sprite (bmp, Data[GRAPPIN0].dat, dx, obj.y);

	}

      //a gauche
      if (obj.dir == 1)
	{

	  dx = pp.x;
	  for (i = pp.x; i > obj.x; i -= GRAPPIN_VIT)
	    {
	      dx = i;
	      draw_sprite_h_flip (bmp, Data[GRAPPIN1].dat, dx, obj.y);
	    }
	  draw_sprite_h_flip (bmp, Data[GRAPPIN0].dat, dx, obj.y);

	}

      //en haut
      if (obj.dir == 2)
	{

	  dx = pp.y;
	  for (i = pp.y; i > obj.y; i -= GRAPPIN_VIT)
	    {
	      dx = i;
	      rotate_sprite (bmp, Data[GRAPPIN1].dat, obj.x, dx,
			     itofix (190));
	    }
	  rotate_sprite (bmp, Data[GRAPPIN0].dat, obj.x, dx, itofix (190));

	}

      //en bas
      if (obj.dir == 3)
	{

	  dx = pp.y;
	  for (i = 0; i < (obj.y - pp.y) / GRAPPIN_VIT; i++)
	    {
	      dx += GRAPPIN_VIT;
	      rotate_sprite (bmp, Data[GRAPPIN1].dat, obj.x, dx,
			     itofix (-190));
	    }
	  rotate_sprite (bmp, Data[GRAPPIN0].dat, obj.x, dx, itofix (-190));

	}



    }
}

/**************** LAporte **********************/
int
LAporte(int boutton){
		switch(boutton){
				case 63 : return 51; // porte gris
			    case 84 : return 86; //  porte bleu
				case 85 : return 87; // porte jaune
				case -1 : return 127;		 
		}
		return -1;
}

/*************************** reshow_bibane ****************/
int
reshow_bibane(int boutton){
	  int xp, yp, d = 0, r;
  for (yp = 0; yp < SCREEN_H - 1; yp += 20)
    {
      for (xp = 0; xp < SCREEN_W - 1; xp += 20)
	{
	  r = Map.show[2][d];
	  if (r == LAporte(boutton))
	    {
		  Map.show[0][d] = Map.show[2][d];
		  Map.show[2][d] = Map.show[1][d];

	    }
	  d++;
	}
    }

}


//clear_bibane : efface les portes de la couleur du boutton
int
clear_bibane (int boutton)
{
  int xp, yp, d = 0, r;
  int t = LAporte (boutton);
  for (yp = 0; yp < SCREEN_H - 1; yp += 20)
    {
      for (xp = 0; xp < SCREEN_W - 1; xp += 20)
	{
	  r = Map.show[0][d];
	  if (r == t)
	    {
	      Map.show[2][d] = Map.show[0][d];
		  Map.show[0][d] = Map.show[1][d];

	    }
	  d++;
	}
    }
}


//destroy_perso
int
destroy_perso (PERSO *p)
{
  if(p->item) {
     free(p->item);
	 p->item=0;
  }
  if (p->images){
    free (p->images);
	p->images=0;
  }
  if (p->name){
    free (p->name);
	p->name=0;
  }
  if (p->items){
    free (p->items);
	p->items=0;
  }
}


/*stage_to_maison */
int
stage_to_maison (int st)
{
  switch (st)
    {
    case 0:
      return 60;
    case 1:
      return 61;
    case 4:
      return 62;
    case 18:
      return 88;
    case 39:
      return 101;
    case 27:
      return 63;
    case 40:
      return 132;
    case 168:
      return 200;
    case 171:
      return 201;
    case 2 :
      return 202;
    case 169:
      return 203;
    case 163:
      return 204;
    case 190:
      return 232;
    case 176:
      return 261;
    }
}

int
iseau(int obs){
	switch(obs){
		case 40: return 1;
	}
	return 0;
}

// is_normal_perso
int is_normal_perso (int obs){
	if(is_perso (obs)){
		if(obs != 40 && obs != 68 && obs != 75 &&  obs != 111) return 1; 
	}
	return 0;
}
//is_perso
int
is_perso (int obs)
{
  switch (obs)
    {
    case 12:
      return 1;
    case 23:
      return 2;
    case 33:
      return 3;
    case 35:
      return 4;
    case 36:
      return 5;
    case 37:
      return 8;
    case 40:
      return 9;
    case 68:
      return 10;
    case 72:
      return 11;
    case 75:
      return 12;
     case 93:
      return 13;

     case 103:
      return 14;
     case 105:
      return 15;
     case 96:
      return 16;
     case 111:
      return 17;
     case 112:
      return 18;
     case 113:
      return 19;

    }
  return 0;
}



int
perso_genre (int per){
	switch(per){
		case 14:return 1;
		case 15:return 1;
	}
	return 0;
}


//hbs
// fonction qui effectue une BOUNDING COLLISION
int
hbs (void)
{
  int d = pp.dir, d1x, d1y, d2x, d2y, c, vit = pp.vit;
  if (nomarcher)
    return 0;
  if (d == 0)
    {
      d1x = ((pp.x) / 20) + 1;
      d1y = (pp.y + vit) / 20;
      d2x = ((pp.x) / 20) + 1;
      d2y = ((pp.y - vit) / 20) + 1;
    }
  if (d == 1)
    {
      d1x = ((pp.x) / 20);
      d1y = (pp.y + vit) / 20;
      d2x = ((pp.x) / 20);
      d2y = ((pp.y - vit) / 20) + 1;
    }
  if (d == 2)
    {
      d1x = ((pp.x + vit) / 20);
      d1y = ((pp.y) / 20);
      d2x = ((pp.x - vit) / 20) + 1;
      d2y = ((pp.y) / 20);
    }
  if (d == 3)
    {
      d1x = ((pp.x + vit) / 20);
      d1y = ((pp.y) / 20) + 1;
      d2x = ((pp.x - vit) / 20) + 1;
      d2y = ((pp.y) / 20) + 1;
    }
  pp.obs1 = Map.show[0][d1x + d1y * 16];
  pp.obs2 = Map.show[0][d2x + d2y * 16];

  test (d1x, d1y);
  test (d2x, d2y);
  pp.pc1x = d1x;
  pp.pc1y = d1y;
  pp.pc2x = d2x;
  pp.pc2y = d2y;

  c = Map.hbst[pp.obs1] & Map.hbst[pp.obs2];
  if(PPSURF && iseau (pp.obs1) && iseau(pp.obs2) && !c) return !c;
  return c;

}

/*return_coffre*/
int
return_coffre (int st)
{
  switch (st)
    {
    case 85:
      return OBJ_CLEBOSS;
    case 86:
      return OBJ_50ARG;
    case 72:
      return OBJ_GANTS;
    case 80:
      return OBJ_50ARG;
    case 71:
      return OBJ_COEUR;
    case 89:
      return OBJ_50ARG;
    case 62:
      return OBJ_1COEUR;
    case 103 : return OBJ_25ARG;
    case 110 : return OBJ_CLEBOSS;
    case 107 : return OBJ_1COEUR;
    case 111 : return OBJ_CLEF;
    case 114 : return OBJ_25ARG;
    case 112 : return OBJ_50ARG;
    case 116 : return OBJ_CLEF;
    case 117 : return OBJ_BOTTES;
    case 104 : return OBJ_CLEF;
    case 64  : return OBJ_CLEDONJON;
    case 145 : return OBJ_1COEUR;	  
    case 139 : return OBJ_CLEF;	   
    case 146 : return OBJ_CLEBOSS;	   
    case 134 : return OBJ_CLEF;	     
    case 186 : return OBJ_FLEURS;      
    case 95  : return OBJ_EPEEX;
    case 97  : return OBJ_EMERAUDE;	  
    case 224 : return OBJ_BOMBE;	       
    case 210 : return OBJ_CLEF;
    case 225 : return OBJ_CLEBOSS;
    case 226 : return OBJ_1COEUR;
    case 174 : return OBJ_MAGIE;
    case 241 : return OBJ_CLEF;
   	       
	       
    }
  return 0;
}

/*set_x_y*/
int
set_x_y (int x, int y)
{
  int s = (x / Map.w) + y;
  if (!Map.hbst[Map.show[0][s + 1]])
    {
      pp.x = x + 20;
      pp.y = y;
    }
  else if (!Map.hbst[Map.show[0][s - 1]])
    {
      pp.x = x - 20;
      pp.y = y;
    }
  else if (!Map.hbst[Map.show[0][s - Map.w]])
    {
      pp.x = x;
      pp.y = y - 20;
    }
  else if (!Map.hbst[Map.show[0][s + Map.w]])
    {
      pp.x = x;
      pp.y = y + 20;
    }

}


/*stage_obs*/
int
stage_obs (int st, int obs)
{
  int xp, yp, d = 0;
  Map.stage = st;
  load_all_screen_map ();

  for (yp = 0; yp < SCREEN_H - 1; yp += 20)
    {
      for (xp = 0; xp < SCREEN_W - 1; xp += 20)
	{
	  if (Map.show[0][d] == obs)
	    {
	      set_x_y (xp, yp);
	      return 0;
	    }
	  d++;
	}
    }
}


//coffre
int
escalier (void)
{
  int e = 41;

  switch (Map.stage)
    {
    case 77:
      stage_obs (85, e);
      break;
    case 85:
      stage_obs (77, e);
      break;
    case 86:
      stage_obs (71, e);
      break;
    case 71:
      stage_obs (86, e);
      break;
    case 1:
      stage_obs (89, e);
      break;
    case 89:
      stage_obs (1, e);
      break;
    case 26:
      stage_obs (90, e);
      break;
    case 90:
      stage_obs (26, e);
      break;
    case 9:
      stage_obs (91, e);
      break;
    case 91:
      stage_obs (9, e);
      break;
    case 92:
      stage_obs (12, e);
      break;
    case 12:
      stage_obs (92, e);
      break;
	case 110 :
	  stage_obs(113 , e);
	  break;
	 case 113:
	  stage_obs(110 , e);
	 break;

	 case 120 :
	 stage_obs(101 , e);
	 break;

	 case 27:
	 stage_obs(93,e);
	 break;
	 case 93:
	 stage_obs(27,e);
	 break;

	 case 94:
	 stage_obs (40,e);
	 break;
	 case 40:
	 stage_obs(94,e);
	 break;
	 case 136:
	 stage_obs(145,e);
	 break;
	 case 145:
	 stage_obs(136,e);
	 break;
	 case 137:
	 stage_obs(146,e);
	 break;
	 case 146:
	 stage_obs(137,e);
	 break;
	 case 139:
	 stage_obs(153,e);
	 break;
	 case 153:
	 stage_obs(139,e);
	 break;
	 case 57:
	 stage_obs (95,e);
	 
	 break;
	 case 95:
	 stage_obs(57,e);
	 break;
	 case 49:
	 stage_obs (96,e);
	 break;
	 case 96:
	 stage_obs(49,e);
	 break;
	case 211:
	 stage_obs(225,e);
	break;
	case 225:
	stage_obs(211,e);
	break;
    }
}

//fanfare
int
fanfare (BITMAP * b, int im, int x, int y)
{
  int i, o;
  BITMAP *r = create_bitmap (SCREEN_W, SCREEN_H);
  o = midi_pos;

  for (i = 0; i < 15; i++)
    {
      blit (b, r, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
      draw_sprite (r, Data[im].dat, x, y - i);
      blit (r, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
      rest (100);
    }

  if (r)
    destroy_bitmap (r);

}

/*prend_coffre*/
int
prend_coffre (int genre, int x, int y)
{
  int im = 0, o;
  char *info = 0, *info2 = 0;
  switch (genre)
  {
    case OBJ_CLEDONJON:
    im =  CLEF2;
    info = "Cle du donjon";
    info2 = "avec cette cle , vous pouvez entrer dans un donjon";
    add_troc_item (CLEF2);
    break;
    case OBJ_CLEBOSS:
      im = CLEF1;
      pp.cleboss = 1;
      info = "Cle Du Boss";
      info2 =
	"Vous pouvez maintenant entrer dans la cachette du maitre du donjon";
      break;
    case OBJ_50ARG:
      im = DIAM0;
      pp.arg += 50;
      info = "50 arg";
      break;
    case OBJ_GANTS:
      im = GANT;
      ADD_ITEM (I_GANT);
      info = "les GANTS";
      info2 = "avec les gants vous pourrez detruire les pierres grises";
      break;
    case OBJ_COEUR:
      im = VIE0;
      pp.hpmax += 2;
      pp.hp = pp.hpmax;
      info = "2 COEURS";
      break;
    case OBJ_1COEUR:
      im = VIE0;
      pp.hpmax++;
      info = "1 COEUR";
      break;
	case OBJ_CLEF :
	  im = CLEF0;
	  pp.clef++;
	  info = "Clef";
	  info2 = "vous pourrez avec la clef ouvrir une porte grise verouillee";
	  break;
	case OBJ_25ARG :
	  im = DIAM0;
	  pp.arg+=25;
	  info = "25 arg";
	  break;
	case OBJ_BOTTES :
	  im = BOTTES;
	  ADD_ITEM(I_BOTTES);
	  info = "les Bottes ! Avec les bottes vous pouvez marcher plus rapidment";
	  info2 = "en plus,deplacer beaucoup d'autres genres de blocs !";
	  break;
	 case OBJ_FLEURS :
	  im = FLEUR0;
	  info = "FleurS";
	  info2 = "fleur mysterieuse qui produit ce qu'on appele de la 'Magie'";
	  add_troc_item (FLEUR0);
	  break;
	 case OBJ_EPEEX:
	  im = EPEE10;
	  info = "EpeeX";
	  pp.pvfrappe++;
	  set_it (I_EPEE,EPEE10,EPEE11);
	  break;
	 case OBJ_EMERAUDE:
	  im = DIAM1;
	  add_troc_item (DIAM1);
	  info = "Emeraude sacree";
	  break;
	 case OBJ_MAGIE:
	  im =  OBJ4;
	  add_troc_item (im);
	  info = "Sac magique";
	  info2 = "permet avec la combinaison avec la fleurS de construire une Magie";
	break;
	case OBJ_BOMBE:
	  im = BOMB00;
	  ADD_ITEM(I_BOMBE);
	  info = "Bombe";
	  info2 = "vous pouvez avec cette bombe exploser les murs faibles";
	  break;
    }
  if (genre)
    {
      o = midi_pos;
      play_midi (Data[FANFARE1].dat, 0);
      fanfare (buffer, im, x, y);
      parle ("Vous recevez", info, info2, 0);
      rest (3000);
      play_place_midi (Map.place);
      midi_seek (o);
    }

}


/************************** test *********************************/
int
test (int pcx, int pcy)
{
  int s = pcx + pcy * 16, st, prog, r, dx = 0, dy = 0, f1, f2;
  int l = Map.show[0][s];
  int i;
  int ab;
  int t;	
  show_bulle = -1; 
  poll_keyboard ();
  if (l != 62 && l != 60 && (l != 83 || obj.cur != I_BOTTES))
    appui = 0;
/************ parler  ************/
  if (t=is_normal_perso (l))
    {
      int d = ( (t != 9) && (t != 17));
      if(d) show_bulle = BULLE0;
      if(BTSPACE){
	        show_bulle=-1;
	        affiche (buffer);
	        PARLE_VILLAGE (Map.stage, pcx, pcy);
      }
      if(d) show_bulle = BULLE0;
    }
  /*********** LES BLOCS DEPLACABLES ************/
  if ((l == 62 || l == 60 || (l == 83 && obj.cur == I_BOTTES))
      && obj.cur != I_GRAPPIN)
    {
      appui++;
      if (appui >= 20)
	{
	  int COUNT=(obj.cur==I_BOTTES)?10:40;
	  nofrappe = 1;
	  appui = 0;
	  f1 = pp.x;
	  f2 = pp.y;
	  if (pp.dir == 0 && !Map.hbst[Map.show[0][s + 1]])
	    goto fin;
	  else if (pp.dir == 1 && !Map.hbst[Map.show[0][s - 1]])
	    goto fin;
	  else if (pp.dir == 2 && !Map.hbst[Map.show[0][s - Map.w]])
	    goto fin;
	  else if (pp.dir == 3 && !Map.hbst[Map.show[0][s + Map.w]])
	    goto fin;
	  if(LAporte(Map.show[1][s]) != -1)
	  reshow_bibane(Map.show[1][s]);
 
	  Map.show[0][s] = Map.show[1][s];
	  Map.show[1][s] = Map.show[2][s];
	  for (i = 0; i < 20; i++)
	    {
	      if (pp.dir == 0)
		dx = i;
	      else if (pp.dir == 1)
		dx = -i;
	      else if (pp.dir == 2)
		dy = -i;
	      else if (pp.dir == 3)
		dy = i;
	      ANIMATION ();
	      affiche (buffer);
	      draw_sprite (buffer, Data[Map.images[l]].dat, pcx * 20 + dx,
			   pcy * 20 + dy);
	      pp.x = f1 + dx;
	      pp.y = f2 + dy;
	      blit (buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	      rest (COUNT);
		  
	    }
	  if (pp.dir == 0)
	    r = s + 1;
	  else if (pp.dir == 1)
	    r = s - 1;
	  else if (pp.dir == 2)
	    r = s - Map.w;
	  else if (pp.dir == 3)
	    r = s + Map.w;
	  f1 = Map.show[0][r];
	  Map.show[2][r] = Map.show[1][r];
	  Map.show[1][r] = f1;
	  Map.show[0][r] = l;
	  
	  if (LAporte(f1) != -1 ){ // BOUT0,BOUT1,BOUT2
	    clear_bibane (f1);
	}
	  
	fin:

	  if (0)
	    printf ("");

	  nofrappe = 0;
	}
    }
  
    if( (ab=is_sphere (l))){
	    int b;
	    int a=-1;

	    if(BTSPACE){
            b =Map.images[l];
	    for(i = 0 ; i < max_troc ;i++){
		    if(is_sphere_image (troc[i])){
			    a=i;
		    }
	    }
	    parle ("vous trouvez une sphere , la prendre ?",NULL,NULL,NULL);
	    if(input("Prendre","Ne pas prendre")==0){
		    if(a == -1){
			    sphere_action (Map.stage , pcx,pcy , (0) , ab,b); /* 0 : prendre*/
			    add_troc_item (b);
			    change_obstacle (Map.stage,0,s,Map.show[1][s]);
			    change_obstacle (Map.stage,2,s,Map.show[0][s]);
			    load_all_screen_map ();
			    return 0;
		    }
		    else parle ("vous ne pouvez pas prendre plus d'une sphere avec vous",NULL,NULL,NULL);
	    }
	    }
    }
    if((l == 102 || l==99)){ /* boutton */

		    if(BTSPACE){
		    	    parle ("vous trouvez un boutton , l'activer ?",NULL,NULL,NULL);
			    if(input("Activer","Ne pas activer")==0) boutton_action (Map.stage,pcx,pcy);
		    }
		    return 0;
    }
		  if((is_sphere(Map.show[2][s]))){
	   		  int a=-1,i;
			  if(BTSPACE){
			  	  parle ("vous trouvez un emplacement d'une sphere",NULL,NULL,NULL);
				  for(i = 0 ; i < max_troc ; i++){
					  if(ab=is_sphere_image (troc[i])) {
			 			  a=i;
						  break;
					  }
				  }
				  
			  if(a==-1)  parle ("mais vous n'avez pas de sphere",NULL,NULL,NULL);
			  else {
				  parle ("deposer la sphere ?",NULL,NULL,NULL);
					  if(input("Deposer","Ne pas deposer")==0){
						  sphere_action(Map.stage,pcx,pcy,(1),0,troc[a]); /* deposer */
						  change_obstacle(Map.stage,0,s,ab);
						  change_obstacle(Map.stage,2,s,Map.show[1][s]);
						  load_all_screen_map ();
						  del_troc_item (a);
					  }
			  }
		  }
		  }

    if(pp.zleq && l!=pp.zleq){
	    pp.zleq=0;

    }
    switch (l)   {
    case 116:
	    pp.zleq=l;
    break;
    case 114:
	    show_bulle=BULLE0;
	    if(BTSPACE){
 	    show_bulle=-1;
	    affiche(buffer);
	    parle("oh ! il y a des petites perles dans l'arbre",NULL,NULL,NULL);
	    parle ("les prendre ???",NULL,NULL,NULL);
	    if(yesno()==0){
		     add_troc_item (MOR0);
		     change_obstacle(Map.stage,0,pcx+pcy*16,75);
		     load_all_screen_map();
		     AFFICHE_BLIT();
	    }
	    }
    break;
    case 115:

	   show_bulle=BULLE0;
    	   if(BTSPACE){
	   int a;
	   show_bulle=-1;
	   affiche(buffer);
    	   parle ("on dirait qu'on doit planter quelque chose ici...",NULL,NULL,NULL);
	   if((a=search_troc_item(MOR0)) != -1){
		   parle ("planter les perles ???",NULL,NULL,NULL);
		   if(yesno()==0){
			   del_troc_item(a);
			   change_obstacle (Map.stage,0,pcx+1+pcy*16,41);
			   play_sfx(SFX8);
			   AFFICHE();
			   parle ("hein?????",NULL,NULL,NULL);
			   load_all_screen_map();
			   AFFICHE_BLIT();
		   }
	   }
	   show_bulle=BULLE0;
	   }
    break;
    
    case 104:
    show_bulle=BULLE0;
    if(BTSPACE){
	    if(Map.prog>=13){
		    show_bulle=-1;
		    affiche(buffer);
		    parle ("tu detruis ce bloc avec la magie noire",NULL,NULL,NULL);
		    Map.show[0][s]=Map.show[1][s];
	    }
	    else parle ("Rien a faire , ca ne bouge pas !",NULL,NULL,NULL);
    }
    break;
    case 108 : /* porte sacree */ 
    if(search_troc_item (CLEF3) != -1 ){
	    int i;
	    int v=1000;
	    show_bulle=BULLE0;
	    if(BTSPACE){
  		    show_bulle=-1;
		    affiche(buffer);
		    del_troc_item (search_troc_item(CLEF3));

		    pp.dir = 0;
		    clear_anim (&pp);	    
		    playmidi (MIDI13);
		    play_sfx (SFX8);
		    rest (v);
		    for(i = 0 ; i < 4 ; i++){
			    AFFICHE_BLIT ();
			    rest (v);
			    pp.dir ++;
		    }
	            rest (v);
		    play_sfx (SFX8);
		    pp.dir = 2;
		    AFFICHE_BLIT ();
		    rest (v*2);
	    	    TELEPORT ();
		    play_sfx (SFX8);
		    clear_bitmap (buffer);
		    BLIT ();
		    rest (v*4);
		    pp.dir = 0;
		    draw_sprite (buffer , Data[pp.images [0]].dat, pp.x , pp.y);
		    BLIT ();
		    parle ("Ou suis je ....????","serai-je arrive dans le monde Magma",NULL,NULL);
		    play_sfx (SFX8);
		    rest (4000);
		    Map.stage = 155;
		    load_all_screen_map ();
		    Map.place = set_place (Map.stage);
		    play_place_midi (Map.place);
		    AFFICHE_BLIT ();
    }
    break;
    case 107 :  /* affiche */
    
    show_bulle=BULLE0;
    if(BTSPACE) {show_bulle=-1;affiche(buffer);AFF (Map.stage,pcx,pcy);}
    show_bulle=BULLE0;	   
    break;	   
    case 61:			// clef

      pp.clef++;
      Map.show[0][s] = Map.show[1][s];
      change_obstacle (Map.stage, 0, s, Map.show[1][s]);
      play_sfx (SFX2);

      break;
      
    case 59:			// coffre
      show_bulle = BULLE0;
      if (obj.cur == I_GRAPPIN)
	break;

      if (BTSPACE)
	{

	  if (pp.dir == 2)
	    {
	      Map.show[0][s] = 60;
	      show_bulle=-1;
	      affiche (buffer);
	      prend_coffre (return_coffre (Map.stage), pcx * 20, pcy * 20);
	      change_obstacle (Map.stage, 0, s, 60);
	    }

         
	}
      break;
    case 55:			//porte verouillee
      if (obj.cur == I_GRAPPIN)
	break;
      if (pp.clef >= 1)
	{
	  pp.clef--;
	  Map.show[0][s] = Map.show[1][s];
	  change_obstacle (Map.stage, 0, s, Map.show[1][s]);
	  play_sfx (SFX18);
	}
      
      break;

    case 94:
      {
      int a;
      if ((a = search_troc_item (CLEF2))>=0){
	      del_troc_item(a);
	      Map.show[0][s]  = Map.show[1][s];
	      change_obstacle (Map.stage,0,s,Map.show[1][s]);
		  play_sfx (SFX18);

      }
      }
      break;
    case 56:
      if (obj.cur == I_GRAPPIN)
	break;
      if (pp.cleboss == 1)
	{
	  parle ("vous entrez chez le maitre du donjon !", NULL, NULL, 0);
	  pp.cleboss = 0;
	  Map.show[0][s] = Map.show[1][s];
	  change_obstacle (Map.stage, 0, s, Map.show[1][s]);

	}
      break;
    case 41:			//escalier
      if (obj.cur == I_GRAPPIN)
	break;
      escalier ();
      fade_out (FADE_ESCALIER_SPEED);
      r = set_place (Map.stage);
      if (Map.place != r)
	{
	  Map.place = r;
	  play_place_midi (Map.place);
	  set_dern();
	  show_title(buffer);
	}
      play_sfx (SFX20);
      clear_anim (&pp);
      affiche (buffer);
      blit (buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
      fade_in (Data[PAL].dat, FADE_ESCALIER_SPEED);
      break;
    case 24:

      if (pp.hezz == 1)
	{
	  pp.hezz_obj = l;
	  Map.show[0][s] = Map.show[1][s];

	}
    if(pp.item[0] != I_GANT && pp.item[1] != I_GANT){
		show_bulle=BULLE0;
		if(key[KEY_SPACE]) {show_bulle=-1;affiche(buffer);parle ("c'est lourd ... je ne peux pas le deplacer !",NULL,NULL,NULL);}
		show_bulle=BULLE0;
    }
      break;
    case 21:			// porte
      if (obj.cur == I_GRAPPIN)
	break;

{
	int m = Map.place;
      SHOW_PERSO = 0;
      /*
         for(i = 0 ; i < 20 ; i++){
         affiche(buffer);
         blit(Data[P30].dat,buffer,0,0,pcx*20,pcy*20,20,20-i); 
         blit(buffer,screen,0,0,0,0,SCREEN_W,SCREEN_H);
         rest(100);
         }
       */
      fade_out (FADE_PORTE_SPEED);

      SHOW_PERSO = 1;
      if (Map.hqst == -1)
	{

	 set_dern();
	  Map.hqst = Map.stage;
	  Map.stage = stage_to_maison (Map.stage);
	  r = set_place (Map.stage);
	  if (r != Map.place)
	    {
	      Map.place = r;
	      play_place_midi (Map.place);
	      	
	    }
	  else
	    play_midi (Data[MIDI3].dat, 1);
	play_sfx (SFX18);
	}

      else
	{
	  Map.stage = Map.hqst;
	  Map.hqst = -1;

	  Map.place = set_place (Map.stage);
	  play_place_midi (Map.place);
	play_sfx (SFX19);

	}
      load_all_screen_map ();
      clear_anim (&pp);
      affiche (buffer);
      blit (buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
      fade_in (Data[PAL].dat, FADE_PORTE_SPEED);
	  PORTE_SCENARIO();
	if(Map.place != m){
		show_title(buffer);
	}

	}
      break;
    case 42:			// trou
      if (obj.cur == I_GRAPPIN)
	break;
      pp.x = pp.hqx;
      pp.y = pp.hqy;
      load_all_screen_map ();
      pp.hp--;
      break;

    case 10:
      if (obj.en && obj.cur == I_EPEE && !pp.jeter_epee)
	{
	  play_sfx (SFX12);
	  Map.show[0][s] = 1;
	  if ((rand () % 10) == 6)
	    {
	      Map.show[0][s] = 25;
	    }
	  else if (rand () % 10 == 9)
	    {
	      Map.show[0][s] = 69;

	    }

	}
      break;
    case 25:			// argent
      if (obj.cur != I_EPEE && !pp.jeter_epee)
	{
	  if (obj.cur == I_GRAPPIN)
	    {
	      obj.cur = 0;
	      obj.en = 0;
	      nomarcher = 0;
	    }
	  Map.show[0][s] = Map.show[1][s];
	  play_sfx (SFX2);
	  pp.arg++;
	}
      break;
    case 69:			//coeur
      pp.hp++;
      if (pp.hp > pp.hpmax)
	pp.hp = pp.hpmax;
      play_sfx (SFX2);
      Map.show[0][s] = Map.show[1][s];
      if (obj.cur == I_GRAPPIN)
	{
	  obj.cur = 0;
	  obj.en = 0;
	  nomarcher = 0;
	}

      break;

    }

    }
}


//clear_anim
int
clear_anim (PERSO * p)
{
  int i;
  for (i = 0; i < 4; i++)
    {
      p->anim[i] = 0;
    }
}

//marche
int
marcher (int dir)
{
  int r = 0, d, i;
  BITMAP *b;

  if (hbs ())
    {
      if (dir == 0)
	pp.x += pp.vit;
      else if (dir == 1)
	pp.x -= pp.vit;
      else if (dir == 2)
	pp.y -= pp.vit;
      else if (dir == 3)
	pp.y += pp.vit;

	if(PPSURF && (iseau(pp.obs1) ||  iseau(pp.obs2))) {
	if(voice_get_position(surf_voice) == -1 ) {surf_voice=play_sfx (SFX7);}
	}
    }
  r = Map.stage;
  d = Map.place;
  if (pp.x >= SCREEN_W - 20 && dir == 0)
    {
      pp.x = 20;
      Map.stage++;
    }

  else if (pp.x <= 0 && Map.stage >= 1 && dir == 1)
    {
      pp.x = SCREEN_W - 40;
      Map.stage--;
    }
  else if (pp.y <= 0 && Map.stage >= 4 && dir == 2)
    {
      pp.y = SCREEN_H - 40;
      Map.stage -= 4;
    }
  else if (pp.y >= SCREEN_H - 20 && dir == 3)
    {
      pp.y = 20;
      Map.stage += 4;
    }

  if (Map.stage != r)
    {
      if(obj.cur==I_BOMBE && obj.en) {obj.en=0;obj.cur=-1;}
      ep=0; 
      load_all_screen_map ();
      Map.place = set_place (Map.stage);
      if (d != Map.place)
	{
	  set_dern(); 
	  play_place_midi (Map.place);
	  FADE (FADE_NORMAL);

	}

      {
	b = create_bitmap (SCREEN_W, SCREEN_H);
	clear_anim (&pp);
	SHOW_PERSO = 0;
	affiche (b);
	SHOW_PERSO = 1;
	scroll_map (buffer, b, pp.dir, SCROLL_FOIS, SCROLL_DELAY);
	if (b)
	  destroy_bitmap (b);
	affiche (buffer);
	blit (buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);

	if (d != Map.place)
	  {
	    fade_in (Data[PAL].dat, FADE_NORMAL);
	  show_title(buffer);

	  }
	if ((d = boss (Map.stage)))
	  {
		play_boss_midi (d);
	  }
	BOSS = d;

      }
    }

}


//load_screen_persos
int
load_screen_persos (void)
{
  int xp, yp, i = 0, a;
  max_persos = 0;
  for (yp = 0; yp < SCREEN_H - 1; yp += 20)
    {
      for (xp = 0; xp < SCREEN_W - 1; xp += 20)
	{
	  a = is_perso (Map.show[0][i]);
	  if (a)
	    {
	      persos[max_persos].x = xp;
	      persos[max_persos].y = yp;
	      persos[max_persos].dir = rand () % 4;
	      persos[max_persos].ep = 0;
	      persos[max_persos].arg = Map.show[0][i];
	      persos[max_persos].genre = perso_genre (a);
	      //              Map.show[0][i]=Map.show[1][i];  

	      max_persos++;
	    }
	  i++;
	}
    }
}

//anim_persos
int
anim_persos (void)
{
  int i;
  if (counter_persos >= DELAY_PERSOS)
    {
      counter_persos = 0;

      for (i = 0; i < max_persos; i++)
	{
          switch(persos[i].genre){
		case 0:
		  persos[i].ep++;
		  if (persos[i].ep >= 2)
		    persos[i].ep = 0;
		  break;
		case 1:
		  persos[i].ep = (persos[i].ep + 10) % 256;
		  break;
	  }

	 
	}

    }
}

//show_persos
int
show_persos (BITMAP * bmp)
{
  int i, pcx, pcy;
  BITMAP *s = 0, *s2 = 0;
  for (i = 0; i < max_persos; i++)
    {
      int im,im2;
      s2 = Data[Map.images[persos[i].arg]].dat;
      pcx = persos[i].x / 20;
      pcy = persos[i].y / 20;
      im= Map.images[Map.show[1][pcx+pcy*16]];
      im2= Map.images[Map.show[0][pcx+pcy*16]];


      switch(persos[i].genre){
      case 0:
	      
      if (persos[i].ep == 1)
	s = MAKLOUB (s2);
      else
	s = s2;
      
      draw_sprite (bmp, Data[im].dat,
		   persos[i].x, persos[i].y);
      draw_sprite (bmp, s, persos[i].x, persos[i].y);
      if (persos[i].ep == 1)
	destroy_bitmap (s);
      break;

      case 1 :
      rotate_sprite (bmp , Data[im2].dat,persos[i].x,persos[i].y,itofix(persos[i].ep));
      break;
    }
    }
}
int SEARCH_ITEM (int it){
	int i;
	for(i = 1 ; i  <= pp.max_items ; i++){
		if(pp.items [i] == it) return i;
	}
	return 0;
}
//ADD_ITEM
int
ADD_ITEM (int n)
{
  pp.max_items++;
  pp.items[pp.max_items] = n;
}

//SET_ITEM
int
SET_ITEM (int a, int n)
{
  pp.item[a] = n;
}



//init_persos
int
init_persos (void)
{

  persos = (PERSO *) malloc (sizeof (PERSO) * 160);
  if(!persos) err(MEMORY_ERROR);
  max_persos = 0;
  pp.clef = 0;
  pp.x = 40;
  pp.y = 60;
  
  pp.item = (int*)malloc(sizeof(int) * (2));
  if(!pp.item) err(MEMORY_ERROR);
  pp.items = (int *) malloc (sizeof (int) * 10);
  if(!pp.items) err(MEMORY_ERROR);
  
  pp.max_items = 0;


  pp.anim[3] = 0;
  pp.anim[0] = 0;
  pp.hp = 3;
  pp.hpmax = 3;
  pp.arg = 0;

  pp.images = (int *) malloc (sizeof (int) * 19);
  if(!pp.images) err(MEMORY_ERROR);
  pp.vit = 2;
  set_pp_image (0, P00);
  set_pp_image (1, P01);
  set_pp_image (2, P02);

  set_pp_image (3, P20);
  set_pp_image (4, P21);
  set_pp_image (5, P22);


  set_pp_image (6, P30);
  set_pp_image (7, P31);
  set_pp_image (8, P32);

  set_pp_image (9, P00);
  set_pp_image (10, P01);
  set_pp_image (11, P02);

  set_pp_image (12, P0F0);
  set_pp_image (13, P0F1);
  set_pp_image (14, P2F0);
  set_pp_image (15, P2F1);
  set_pp_image (16, P3F0);
  set_pp_image (17, P3F1);
  
  pp.name = (char *) malloc (4);
  if(!pp.name) err(MEMORY_ERROR);
  
  strcpy (pp.name, "Izza");
  
  pp.dir = 3;
  pp.hezz = 0;

  pp.item[0] = 0;
  pp.item[1] = 0;

  ADD_ITEM (I_EPEE);
  /*      
     SET_ITEM(0,1);  // place 0 : EPEE
     SET_ITEM(1,0);  // place 1 : RIEN
   */
}

int
use_item (int n)
{
  if (obj.en)
    return 0;
  //EPEE
  if (pp.item[n] == I_EPEE)
    {
      counter_frappe = 0;
      obj.en = 1;
      obj.dir = pp.dir;
      obj.cur = pp.item[n];
      obj.anim = 0;
      obj.x = pp.x;
      obj.y = pp.y;
      pp.jeter_epee = 0;
      if (pp.hp == pp.hpmax)
	pp.jeter_epee = 1;
      play_sfx (SFX0);

    }
  //GANT
  else if (pp.item[n] == I_GANT)
    {
			int h1,h2;
			hbs();
			h1 = pp.pc1x + pp.pc1y*Map.w;
			h2 = pp.pc2x + pp.pc2y*Map.w;
			if(is_gant(pp.obs1)) Map.show[0][h1]=Map.show[1][h1];
			if(is_gant(pp.obs2) ) Map.show[0][h2]=Map.show[1][h2];
    }
//BOTTES
  else if (pp.item[n] == I_BOTTES)
    {
      obj.en = 1;
      obj.anim = pp.vit;
      obj.cur = pp.item[n];
      play_sfx (SFX5);
      counter_bottes = 0;
    }

//GRAPPIN
  else if (pp.item[n] == I_GRAPPIN)
    {
      obj.en = 1;
      obj.anim = 0;
      nomarcher = 1;
      obj.x = pp.x;
      obj.y = pp.y;
      obj.dir = pp.dir;
      obj.cur = pp.item[n];
      play_sfx (SFX6);
    }
//BOOMERANG
  else if(pp.item[n] == I_BOOMERANG){
		  obj.en=1;
		  obj.anim=0;
		  counter_boom = 0;
		  obj.x = obj.nx = pp.x;
		  obj.y = obj.ny = pp.y;
		  obj.dir = pp.dir;
		  obj.mode = 0;
		  obj.cur = pp.item[n];
  }
  else if(pp.item[n] == I_FLEURS){
	  int a=teleport_stage,b=teleport_x,c=teleport_y;
		play_sfx (SFX8);
		play_sfx (SFX8);
  		TELEPORT ();			  
		teleport_stage=Map.stage;
		teleport_x = pp.x;
		teleport_y = pp.y;
		Map.stage = a;
		pp.x = b;
		pp.y = c;
		load_all_screen_map ();
		play_place_midi (Map.place=set_place(Map.stage));
		FADE (FADE_NORMAL);
		AFFICHE_BLIT ();
		setpal;
  }
  else if(pp.item [n] == I_BOMBE){
	  int x,y;
	  obj.en=1;obj.anim=0;
	  counter_bombe=0;counter_bombe2=0;
	  hbs();
	  obj.x = pp.x;obj.y=pp.y;
	  obj.pc1x=pp.pc1x;obj.pc2x=pp.pc2x;obj.pc1y=pp.pc1y;obj.pc2y=pp.pc2y;
	  if(pp.dir == 0) {obj.pc1x--;obj.pc2x--;}
	  else if(pp.dir==1) {obj.pc1x++;obj.pc2x++;}
	  else if(pp.dir==2) {obj.pc1y--;obj.pc2y--;}
	  else if(pp.dir==3) {obj.pc1y++;obj.pc2y++;}
	  
	  obj.cur = pp.item[n];
  }
  else if( pp.item [n] == I_FEU){
	  obj.en = 1 ; obj.anim = 0;
	  hbs ();
	  obj.x = pp.x; obj.y = pp.y;
	  obj.cur = pp.item [n];
	  obj.dir = pp.dir;
	  counter_bombe = 0;
         play_sfx (SFX16);

  }
  
}


/**************** destroy_persos ************/
int
destroy_persos (void)
{
  int i;
  if(persos) {free(persos);persos=0;}
}

/***************************** TROCS ************************/

/*add_troc_item */		
int
add_troc_item (int d)
{
  troc[max_troc] = d;
  max_troc++;
}

/* del_troc_item */
int
del_troc_item(int d){
	int new_max=0,i;
	
	for(i =  0 ; i <max_troc ;i++){
		if(i != d){
			troc[new_max] = troc[i];
			new_max++;
		}
	}
	max_troc = new_max;
}
/*search_troc_item*/
int
search_troc_item (int d)
{
  int i;
  for (i = 0; i < max_troc; i++)
    {
      if (troc[i] == d)
	return i;
    }
  return -1;
}

/*set_troc_item*/
int
set_troc_item (int d, int set)
{
  troc[d] = set;
}

/*TROC*/
int
TROC (int obj_donner, int obj_recevoir)
{
  int i;
  if (obj_donner == -1)
    {
      add_troc_item (obj_recevoir);
      return 0;
    }
  i = search_troc_item (obj_donner);
  if (i == -1)
    return i;
  set_troc_item (i, obj_recevoir);
}

/* ret_troc */
int
ret_troc (int num)
{
  return troc[num];
}

/* if_collision */
int
if_collision (BITMAP * b1, BITMAP * b2, int x1, int y1, int x2, int y2)
{
 	
  PMASK *p1, *p2;
  int ret;
  
  /*return coll (x1,y1,b1->w,b1->h,x2,y2,b2->w,b2->h);*/
	
  
  if(!b1 || !b2) return 0;
  p1 = create_allegro_pmask (b1);
  p2 = create_allegro_pmask (b2);
  if(!p1 || !p2) return 0;
  ret = check_pmask_collision (p1, p2, x1, y1, x2, y2);
  if(p2) {destroy_pmask (p2);p2=0;}
  if(p1) {destroy_pmask (p1);p1=0;}
  return ret;
  
}

/* ret_troc */
int*
get_troc() {return troc;}

