/********************************************************
 * ZELDA::SCENARIO.C  **********************************************
 ********************************************************/

#include "internal.h"
int cle_prog=0;

void AFF (int st,int pcx,int pcy){
	if(st == 142){
		parle ("fais le meme modele des spheres en haut avec les spheres en bas",NULL,NULL,NULL);
	}
	else if(st == 168){
		parle ("Chef du village",NULL,NULL,NULL);
	}
	else if(st == 169){
		parle ("Epicerie d'Afia",NULL,NULL,NULL);
	}
	else if(st == 171){
		parle ("Maison de Faras",NULL,NULL,NULL);
	}
	else if(st == 176){
		parle ("Boutique magique",NULL,NULL,NULL);
	}
}

void start_shop (int num){
	BITMAP *save;
	FONT *f=sfont;
	int d=15,p,hq=0;
	draw_parle (buffer,d,d,SCREEN_W-d-10,SCREEN_H-d-10);
	save=create_bitmap(SCREEN_W,SCREEN_H);
	bmp_dup(buffer,save);
	if(num == 0){
		re:
		textout(buffer,f,"Potion de Vie : 40  rubis",d+6,d+3,15);
		textout(buffer,f,"10 Fleches    : 50  rubis",d+6,d+13,15);
		textout(buffer,f,"Ether         : 50  rubis",d+6,d+23,15);

		textout(buffer,f,"Retour",d+6,d+33,9);
		textprintf(buffer,f,d+6,100,15,"Rubis : %i",pp.arg);
		p = Choix (0,d,4,10,hq);
		hq=p;
		if(p != 3){
			
		if(p == 0) buy (O_POTION);
		else if(p == 1) buy (O_FLECHE);
		else if(p == 2) buy (O_ETHER);
		bmp_dup (save,buffer);
		goto re;
		}
	}
	else if(num == 1){
		rre:
		textout(buffer,f,"Magie Feu     : 100  rubis",d+6,d+3,15);
		textout(buffer,f,"Magie Glace   : 100  rubis",d+6,d+13,15);
		textout(buffer,f,"Magie Foudre  : 100  rubis",d+6,d+23,15);

		textout(buffer,f,"Retour",d+6,d+33,9);
		textprintf(buffer,f,d+6,100,15,"Rubis : %i",pp.arg);
		p = Choix (0,d,4,10,hq);
		hq=p;
		if(p != 3){
			
		if(p == 0) buy (O_FEU);
		else if(p == 1) buy (O_GLACE);
		else if(p == 2) buy (O_FOUDRE);
		bmp_dup (save,buffer);
		goto  rre;
		}
	}

	destroy_bitmap(save);

}

//PARLE_VILLAGE
int
PARLE_VILLAGE (int st, int pcx, int pcy)
{
  int o = pcx+pcy*16;
  if(st == 61) {
	  parle ("Bienvenue dans mon magasin , servez vous....",NULL,NULL,"mag1");
	  start_shop (0);
  }
  if(st == 261){
	  parle ("Bienvenue dans la boutique magique","donnez moi des sacs magiques et je les transformerai en Magie",NULL,NULL);
	  if(search_troc_item (OBJ4) != -1){
	  start_shop (1);
	  }
	  else parle ("Revenez quand vous aurez un SAC MAGIQUE",NULL,NULL,NULL);
  }
   if(st == 200){
	   parle ("Chef : salutations , vous etes le touriste a ce que je vois","bienvenue mille fois alors dans le village Afia , faites comme","chez vous !! Baignez vous si vous voulez dans ma piscine Magma",NULL);
   }
   if(st == 203){
	   parle ("bienvenue chez Ohho !",NULL,NULL,NULL);
	   start_shop (0);
   }
   if(st == 169){
	  if(pcx == 2 && pcy == 2){
		  parle ("Roro : notre nourriture est toujours a base","du magma et on dit que les ressources de ce dernier sont infinies alors notre","race ne devrait pas dispraitre!!je suis un scientifique n'est ce pas???","vil5");
	  }
	  else if(pcx == 11 && pcy == 1){
		  parle ("Mimi : quel regal de boire du magma Pure",NULL,NULL,NULL);
	  }
	  else if(pcx == 11 && pcy == 4){
		  parle ("Momo : taaaaaaaaaata ta ta la lala la la !!!","qu'est ce qu'il y a ??? je fais une douche en chantant ??? c'est mal ??",NULL,NULL);
	  }
	  else if(pcx == 12 && pcy == 7){
		  parle ("Meme : un minable appele AZZI est venu il y a pas longtemps","dans les environs pour rechercher les crystaux",NULL,NULL);
	  }
   }
   if(st == 168){
	   if(pcx == pcy == 1){
		   parle ("Rara : ah ! c'est toi le touriste dont m'a parle Faras !","dis moi , dis moi quelle est ta meilleure boisson ???",NULL,NULL);
		   parle (pp.name,"moi .... je ne sais pas , la Limonade!",NULL,NULL);
		   parle ("Rara : quoi ????? jamais entendu parler , quant a moi , j'aime","le magma avec le citron , c'est tellement delicieux",NULL,NULL);
		   parle (pp.name,"hein ??? Beuuurk...","comment tu fais pour boire ca",NULL);
		   parle ("Rara : tu dois y gouter mon petit avant de critiquer","c'est la devise des Afiaiens",NULL,NULL);
	   }
	   else if(pcx == 13 && pcy == 1){
		   parle ("Riri :  t'es le touriste ??? d'ou tu viens ??? tu portes des vetements","bizarres et ton visage est bizzare !",NULL,NULL);
	   }
   }
   if(st == 172){
	   parle ("nous sommes les guerriers de Afia , notre chef est Faras",NULL,NULL,NULL);
   }
   if(Map.show[0][o] == 113 && st == 202){
	   if(Map.prog==12){
		   parle ("MEGNOR : ........",NULL,NULL,NULL);
	   }
	   if(Map.prog==11){
		   int a;
		   if((a=search_troc_item(DIAM1))==-1){
		   parle("MEGNOR : je vois que tu n'as pas encore l'objet...",NULL,NULL,NULL);
		   }
		   else {
			   del_troc_item(a);
			   parle ("MEGNOR : tu l'as trouve ??? EXELLENT!Prends les pouvoirs","des mages noir,tu en as le droit",NULL,NULL);
			   parle ("MEGNOR : voila !",NULL,NULL,NULL);
			   play_sfx (SFX10);
			   parle ("MEGNOR : merci ! merci ! merci pour tout",NULL,NULL,NULL);
			   parle (pp.name,"????? hein ???",NULL,NULL);
			   parle (pp.name,"JE SUIS DEVENU UN MAGE NOIR!",NULL,NULL);
			   parle ("MEGNOR : oui , et maintenant tu as le droit d'entrer dans les donjons","du monde Magma,mon petit,et de pratiquer de la magie",NULL,NULL);
			   parle (pp.name,"mais ou pourrai je trouver la magie??",NULL,NULL);
			   parle ("MEGNOR : dans les sources de magies,tu dois y mettre la FleurS afin d'obtenir","la magie",NULL,NULL);
			   parle (pp.name,"merci pour tout",NULL,NULL);
			   Map.prog++;
		   }
		   
		   
	   }
	   if(Map.prog == 10){
		   parle ("MEGNOR : Que puis-je pour vous ??",NULL,NULL,NULL);
		   parle (pp.name,"je veux devenir un MageNoir",NULL,NULL);
		   parle ("MEGNOR : un mage...mais je ne donne pas mes pouvoirs","a n'importe qui",NULL,NULL);
		   parle (pp.name,"je suis pret a tout!faites moi ce que vous voulez",NULL,NULL);
		   parle ("MEGNOR : d'accord...rapporte moi l'Emeraude sacree qui se","trouve dans le desert",NULL,NULL);
		   parle (pp.name,"d'accord!!j'y vais",NULL,NULL);
		   change_obstacle(42,0,7+6*16,get_obs(Map,42,1,7+6*16));
		   Map.prog++;
	   }
   }
   if(Map.show[0][o] == 96  && pp.dir == 2) {
	   if(st == 198){ /* maison de faras */
		   
		   if(Map.prog == 9){
			   parle ("Faras : bonjour !",NULL,NULL,NULL);
			   parle (pp.name,"la FleurS est prete ??",NULL,NULL);
			   parle ("Faras : tout a fait ! maitenant , tu peux retourner","dans ton monde avec cette FleurS",NULL,NULL);
			   parle (pp.name,"a part ca ??",NULL,NULL);
			   parle ("Faras : avec le temps , la FleurS produira des magies","Noires , mais comme j'ai dit seul","un mage noir peut utiliser les magies de feu,glace..",NULL);
			   parle (pp.name,"et qu'est ce qu'on doit faire pour devenir","un mage noir ??",NULL);
			   parle ("Faras : bonne question ! pour le devenir,il te faut parler avec MEGNOR","le maitre de la magie,il est tres vieux maintenant"," cherche le dans ton monde au village,je ne sais pas ou il est exactement",NULL);
			   parle (pp.name,"d'accord !! je chercherai",NULL,NULL);
			   parle ("Faras : tu sais , si tu veux entrer aux 3 donjons du monde magma","tu devrais devenir un mage noir","alors c'est obligatoire tout ce que tu fais",NULL);
			   parle ("Faras : prend la FleurS",NULL,NULL,NULL);
			   change_obstacle (202,0,7+2*16,113);
			   ADD_ITEM (I_FLEURS);
			   Map.prog ++;
		   }
		   if(Map.prog == 10){
			   parle ("Faras : bonne chance !! je t'attends avec impatience",NULL,NULL,NULL);
		   }
		   if(Map.prog==12){
			   parle ("Faras : tu es devenu un mage noir !!! exellent!!!",NULL,NULL,NULL);
			   Map.prog++;
		   }
		   if(Map.prog==13){
			   
			   if(n_crystal < 4) parle ("Faras : qu'on en finisse avec ce AZZI,va maintenant","a gauche du village pour le premier donjon",NULL,NULL);
			   else {
				   parle ("Faras : l'avenir de la terre depends de toi , il ne te reste que","deux crystals a ramener pour vaincre AZZI",NULL,NULL);
				   parle ("Faras : le deuxieme donjon se trouve pres de","la zone ou tu as trouve la FleurS",NULL,NULL);
			   }
		   }

	   }
	   if(st == 201){ /* maison de faras */
		   if(Map.prog == 7){
		   int d = 13+5*16;
		   parle ("Faras : salut ! tu t'y habitues avec les magmaiens Afiaiens ??",NULL,NULL,NULL);
		   parle (pp.name,"ouaip ... mais ils sont anormals! non??",NULL,NULL);
		   parle ("Faras : mais pour eux c'est toi qui est anormal ! bon ...","c'est pas le moment de parler de ca !","bon ... peux tu me rendre service??",NULL);
		   parle (pp.name,"si c'est pour le bien de l'humanite , et contre AZZI","je ne vois pas pourquoi je dirai non !",NULL);
		   parle ("Faras : Bon,tu peux me chercher un objet qui s'appele la FleurS","qui se trouve au Mont F a l'est du village??",NULL,NULL);
		   parle (pp.name, "C'est quoi cette FleurS ??",NULL,NULL);
		   parle ("Faras : la FleurS nous donnera de grands pouvoirs","appeles la 'Magie'",NULL,NULL);
		   parle ("Faras : et seul un Mage Noir peut l'utiliser","y compris la magie de RETOUR","qui te permet de retourner dans la porte sacree ,dans ton monde",NULL);
		   change_obstacle (172 , 0 , d , 109);
		   Map.prog ++;
		   }
		   if(Map.prog == 8 ){
			   if(search_troc_item(FLEUR0)==-1){
				   parle ("Faras : va vers l'est comme j'ai dit , attention a toi","et reste mefiant","Bonne chance",NULL);
			   }
			   else {
				int v=Map.show[0][pcx+pcy*Map.w];
				Map.prog ++;
				del_troc_item (search_troc_item(FLEUR0));
				parle ("Faras : ah tu l'as ??? bon travail !",NULL,NULL,NULL);
				parle (pp.name,"merci beaucoup!!",NULL,NULL);
				parle ("Faras : bon , tu dois maitenant te reposer","laisse moi fabriquer quelques choses avec","cette FleurS , on va avoir des surprises demain",NULL);
				playmidi (MIDI16);
				FADE (FADE_NORMAL);
				clear_bitmap (buffer);
				BLIT ();
				rest (4000);
				parle (pp.name , "......Quand va on finir avec ce AZZI ???" , NULL , NULL);
				parle (pp.name , "pourquoi c'est moi qui doit faire tout ca ??",NULL,NULL);
				rest (4000);
				parle (pp.name , "C'est pour ma mere ou pour sauver le monde ??",NULL,NULL);
				parle (pp.name , "Je crois que ca devient plus sur 'sauver le monde'",NULL,NULL);
				parle (pp.name , "Etre l'elu ... serais je l'elu ??? tout le monde compte sur moi ...",NULL,NULL);
				rest (4000);
				parle (pp.name , "Pourquoi pas Faras ???","des soldats , ou des guerriers qui sont faits pour ca ??",NULL);
				parle (pp.name , "je suis l'elu , et je defendrai mon titre","qu'on en finisse !",NULL);
				change_obstacle (Map.stage,0,pcx+pcy*16,Map.show[1][pcx+pcy*Map.w]);

				Map.stage -= 4;
				change_obstacle (Map.stage+1,0,7+5*16,v);

				load_all_screen_map ();
				AFFICHE_BLIT ();
				setpal;
			   }
		   }
	   }
	   
	   else if(st == 135){

		   parle ("??? : entends bien ce que je dis , si tu veux parvenir a ouvrir la porte" ,"ci-dessous tu dois faire preuve d'observation" ,"observe bien tout les obstacles BLEU et tu verras une difference",NULL);
		   parle ("??? : puis tu y trouveras un boutton",NULL,NULL,NULL);
		   parle (pp.name , "Mais qui es tu ??",NULL,NULL);
		   parle ("??? : peu importe qui je suis,...,ce qui importe","c'est toi",NULL,NULL);
		   change_obstacle (st , 0 , o , Map.show[1][o]);
		   load_all_screen_map ();
		   AFFICHE_BLIT ();
		   parle (pp.name , "wow ... il a disparu !! je me demande qui","etait ce mysterieux gars",NULL);
	   }
	   else if(st == 150){
		   parle ("??? : ... je t'attendais , heros , tu es sans doute la plus courageuse","et maline personne que j'ai vu de toute ma vie",NULL,NULL);
		   parle (pp.name , "je peux savoir qui tu es ??",NULL,NULL);
		   parle ("??? : .....",NULL,NULL,NULL);
		   parle ("??? : je vais te donner la competence","pour nager dans les mer",NULL,NULL);
		   parle ("??? : fais on bon usage , ... , et ,..,a bientot",NULL,NULL,NULL);
		   PPSURF = 1;
		   change_obstacle (st , 0 , o , Map.show[1][o]);
		   load_all_screen_map ();
		   AFFICHE_BLIT ();
		   parle (pp.name,"............encore,...il a dis..paru..",NULL,NULL);
		   parle (pp.name,"bon .. maintenant je peux facilement nager dans les mers","pratique , n'est ce pas ?? mais a qui je parle !",NULL);
	   }
	   else if(st == 158){ /* monde magma */
		   int t=calcul_obs(16,9,3);
		   parle ("??? : ...Enfin t'es arrive ,.... , j'attendais depuis longtemps que tu viennes ici","Suis moi ...",NULL,NULL);
		   parle (pp.name,"je ne vais nulle part tant que tu m'as","pas dit qui tu es!",NULL);
		   parle ("??? : hahaha , cette fois , t'a gagne",NULL,NULL,NULL);
		   parle (pp.name,"alors ...",NULL,NULL);
		   parle ("??? : je m'appele Faras , ... , je suis un magmaien ","guerrier de la ville Afia,pere d'un fils assassine,epoux d'une femme assassinee","par AZZI et je prendrais ma vengence !",NULL);
		   parle (pp.name,"je vois...alors pourquoi tu m'a aide dans le donjon??",NULL,NULL);
		   parle ("Faras : parce que je compte sur toi pour eleminer AZZI...ton frere","tu es le seul a pouvoir faire ca",NULL,NULL);
		   parle (pp.name,"tu sais tout a ce que je vois!",NULL,NULL);
		   parle ("Faras : je te prie de prendre les 3 Crystaux rouges qui restent.","pour obtenir avec la collision des Rouges et Bleu l'epee Supreme","afin de detruire AZZI une fois pour toute et guerir ta mere",NULL);
		   parle (pp.name,"comment ca les 3 crystaux rouges qui 'RESTENT'???",NULL,NULL);
		   parle ("Faras : AZZI a malhereusement pris 4 Crystaux rouges et a","eu la magie ultime MAGMA qui lui permet de manipuler tout ce qui","concerne le FEU",NULL);
		   parle (pp.name,"...ca complique les choses",NULL,NULL);
		   parle ("Faras : bon on se retrouve dans le village Afia","suis cette route",NULL,NULL);
		   change_obstacle (Map.stage , 0,t , Map.show[1][t]);
		   load_all_screen_map ();
		   AFFICHE_BLIT ();
	   }

   }
  switch (st)
    {
    
    case 18:
	    if( pp.dir == 2){
		    int obs= Map.obs[0][pcx+(pcy-1)*Map.w];
		    if(Map.prog == 1 && cle_prog==0 ){
			    cle_prog++;
			    parle(
			    "Garde : tu as la permission du Roi ? tu peux entrer"
			    ,NULL,NULL,"garde0");
			    prend_coffre (OBJ_CLEDONJON,pp.x,pp.y);
			    
		    }
		    else if(Map.prog == 0){
			    parle(
			    "Va jouer dans un autre endroit , tu dois avoir la permission","du roi pour entrer",NULL,NULL);
		    }
	    }
    break;	
    
    case 90:
      RUN_SCRIPT (0);		/* le personnage quit vous donne la lettre */
      break;
      
    case 0:

      if (pcx == 2 && pcy == 2)
	{
	  if(cle_prog < 2){	
	  parle
	    ("Nous comptons tous sur toi pour sauver ta mere qui est notre reine",
	     ".......COURAGE!", NULL, "charef");
	  }
	  else if(cle_prog == 2 ){
		  parle
	          ("Tout le secret du troisieme donjon se trouve dans la foret noire",
		   NULL,NULL,"charef2");
	  }
	}

      if (pcx == 14 && pcy == 1)
	{
	  parle
	    ("titi : salut , je suis titi, mon loisir est de collectionner des flacons d'eau",
	     "j'en ai beaucoup et c'est tres passionant", NULL, "titi");
	}

      if (pcx == 3 && pcy == 5)
	{
	  parle
	    ("le premier bout de cristal se trouve dans un donjon au sud du village ",
	     "mais tu peux enter que par permission de ton pere le roi", NULL,
	     "vil1");
	}


      break;
    case 1:
      if (pcx == 3 && pcy == 1)
	{

	  if (Map.prog == 0)
	    {
	      parle
		("va parler avec ton pere pour qu'il puisse te donner la 'PERMISSION'",
		 "d'entrer dans le donjon", NULL, "vil2");
	    }

	  if (Map.prog > 0)
	    {
	      parle
		("pour faire pousser un mur rouge , tu n'as qu'a te mettre",
		 "a cote puis de beaucoup marcher pour ensuite le pousser",
		 NULL, "vil2_1");
	    }

	}
      
      if (pcx == 12 && pcy == 2)
	{
	  if(search_troc_item(OBJ1) < 0 && cle_prog < 2 ){
	  parle
	    ("si seulement tu avais un 'CISEAU ARGENTE' je te donnerai la cle ",
	     "du deuxieme donjon", NULL, "vil0");
	  }
	  
	  if (cle_prog == 1 && search_troc_item(OBJ1)>=0){
		  cle_prog++;
		  parle("oh ! tu as mon ciseau ! je te donne la cle",NULL,NULL,"vil0_1");
		  Troc (OBJ1 , CLEF2);
	  }

	  if(cle_prog >=2) {
		  parle ("On dit que le troisieme donjon est introuvable",NULL,NULL,"vil0_2");

		  
	  }
	}
      break;

    case 2:
      if (pcx == 9 && pcy == 7)
	{

	  parle
	  ("si tu as le plein d'energie tu pourrais lancer ton epee",
	   NULL , NULL , "vil4");

	}
      break;

    case 5:
      if (pcx == 14 && pcy == 1)
	{

	  if (Map.prog < 2)
	    {
	      parle ("azzi va le payer , c'est un monstre !", NULL, NULL,
		     "vil3_1");
	    }

	  else
	    {
	      int a = search_troc_item (OBJ0);
	      if (Map.prog == 2 && a == -1)
		{
		  parle ("tu veux un CISEAU ARGENTE ? je peux te le donner",
			 "si tu me cherches ma lettre que j'ai egare , j'en ai besoin !",
			 NULL, "vil3_2");
		}
	      else if (Map.prog == 2 && a != -1)
		{
		  parle
		    ("mes felecitations ! je vois que tu portes ma lettre",
		     NULL,
		     NULL, "vil3_3");
		  MIDI_FANFARE ();
		  Troc (OBJ0, OBJ1);
		  MIDI_PLACE ();
		  Map.prog++;
		}
	      if (Map.prog > 2)
		{
		  parle ("tu sais qu'il ne reste pas beaucoup de temps ?",
			 "COURAGE !", NULL, "vil3_4");
		}
	    }
	}
      break;
	  /* MAISON HOME */
    case 60:

      if (pcx == 8 && pcy == 3)
	{
	  parle ("mon beau garcon , tu me sauveras ! hein? tu me sauveras ?",
		 NULL, NULL, "mere1");
	}

      if (pcx == 7 && pcy == 3) /* JK*/
	{
	  if(Map.prog == 6){
		          if(n_crystal == 2){
				  parle("pere : courage mon enfant , courage",NULL,NULL,"jk16");
			  }
			  else if(n_crystal == 3){
				  parle("pere : mon fils , tu es entrain de devenir un Heros",
          				 "le sort de la terre est entre tes mains","on ne sait pas ce que projette AZZI","jk17");

				  parle(pp.name,"...... je ferai tout mon possible pour sauver ma mere","et le monde de ce monstre!!","jk18");
				  parle("pere : C'est vrai , ton ambition et ton amour depassent tout..","...",NULL,"jk19");
				  parle("pere : il est tant , mon fils que tu ailles a la porte Sacree","j'ai fait beacoup de recherches a ce sujet","et c'est malheureusement vrai que ce monde existe","jk20");
				  parle("pere : et que AZZI y est parti....","tu dois etre tres prudent , mon fils",NULL,"jk21");
				  parle("pere : tiens , si tu dois avoir cette clef pour entrer",NULL,NULL,"jk22");
				  Troc (-1 , CLEF3); 
				  Map.prog ++;
			  }
			  
			  
	  }
	  if(Map.prog == 7){
		  parle ("pere : la porte sacree se trouve au dela de la grande","cascade d'eau dans la sortie de la foret noire",NULL,"jk23");
	  }
	  
	  if(Map.prog == 5){
			  Map.prog++;
			  parle("pere : une fois de plus , tu ramasse un bout crystal ! EXELLENT,j'en suis fier","et tu as sauve le village de AZZI",NULL,"jk8");
			  parle(pp.name,"AZZI s'est enfui ... et il a d'autres but .....",NULL,"jk9");
			  playmidi(MIDI10);
			  parle("pere : ??? qu'est ce que tu veux dire avec d'autres BUTS!",NULL,NULL,"jk10");
			  parle(pp.name,"AZZI veut se venger du monde en ramassant les 4 bouts du crystal rouge","dans le monde 'MAGMA'","jk11");
			  parle("pere : ....On dit que ce monde est imaginaire mais on dit","que si quelqu'un franchit la porte sacree tenant 3 bouts","du crystal bleu , il entrera dans MAGMA","jk12");
			  parle("pere : ta mere et le monde sont en danger , tu es notre seul espoir","vu que tu as ramasse 2 bouts du crystal tu peux sauver l'humanite",NULL,"jk13");
			  parle(pp.name,"c'est vraiment mon frere !? il est anormal",NULL,"jk14");
			  parle("pere : ceci est une autre histoire....va chercher le troisieme bout",".........",NULL,"jk15");
	  }
	  
	  if (Map.prog == 0)
	    {
	      parle
		("pere : va prendre le premier bout de cristal dans le premier donjon",
		 NULL, NULL, "jk1");
	      parle ("papa ! mais je dois avoir la 'PERMISSION'", NULL, NULL,
		     "jk2");
	      parle ("pere : prends la permission alors !", NULL, NULL,
		     "jk3");
	      Map.prog++;
	    }
	  if (Map.prog > 0)
	    {

	      if (n_crystal != 1 && Map.prog == 1)
		{
		  parle
		    ("pere : va trouver les bout de cristaux , moi ,je m'occuperai de ta mere",
		     NULL, NULL, "jk4");
		}
	      if (n_crystal == 1 && Map.prog == 1)
		{
		  Map.prog++;
		  parle
		    ("pere : Bravo , mon fils tu es le meilleur , mais ce donjon n'etait",
		     "qu'un petit test , alors attention!",
		     "et attends toi au pire ...!", "jk6");
		}

	      if (Map.prog == 2 && n_crystal == 1)
		{
		  parle
		    ("pere : tu dois maintenant trouver la clef du 2eme donjon,je connais un ",
		     "villageois dans ces parages que peut te la donner",
		     NULL, "jk7");
		}

	    }


	  if (!n_crystal)
	    parle
	      ("pere : reviens me joindre quand tu auras le premier bout de cristal",
	       "....je te reserve quelque chose", NULL, "jk5");

	}
      break;

    }
}


/********************* parle_monstre ****************/
void
parle_monstre (int donjon_num)
{
  switch (donjon_num)
    {
    case 1:
      parle
	("Gardien : je suis le gardien du donjon , prepare toi a m'affronter",
	 NULL, NULL, "monstre1");
     break;
	 case 2:
	  parle
	("Vampire : Tu oses me defier pour prendre mon bout de crystal ???",
	 "HA HA HA HA !",NULL,"monstre2");

      break;
    }
}

/******************* Vparle ****************/

int
VParle (int genre)
{
  switch (genre)
    {
    case PARLE_GAGNE_MONSTRE:
      parle ("BRAVO !! vous avez vaincu le mechant monstre !", NULL, NULL,
	     NULL);
      break;
    case PARLE_PERDU:
      parle ("Maleheureusement ,vous n'avez pas pu sauver votre mere . . .",
	     NULL, NULL, NULL);
      break;
    }
}



/************************* RUN_SCRIPT *********************/

int
RUN_SCRIPT (int num)
{
  int i;
  switch (num)
    {
    case 0:
      /* quand le perso qui vous donne la lettre s'enfuit */
      {
	SCRIPT_COMMAND cmd;
	int avant;
	set_script_cmd (&cmd, SCRIPT_CMD_MARCHER);
	AFFICHE ();
	play_midi (Data[FANFARE1].dat, 0);
	parle ("oh ! merci ! merci de m'avoir sauve la vie ! ",
	       "bon , je vais te donner une lettre que j'ai trouve par terre !",
	       "je suis presse", "lettre0");
	
	Troc (-1, OBJ0);
	script_cmd_MARCHER_set (&cmd, CALCUL_OBS (3, 1), 1, 3, 200,
				&counter_script);
	
	play_place_midi (Map.place);
	avant = cmd.obs_index;
	cmd.with_rest = TRUE;
	SCRIPT_EXEC (&cmd);
	cmd.dir = 1;
	SCRIPT_EXEC (&cmd);
	cmd.dir = 3;
	for (i = 0; i < 2; i++)
	  {
	    SCRIPT_EXEC (&cmd);
	  }
	cmd.dir = 0;
	for (i = 0; i < 11; i++)
	  {
	    SCRIPT_EXEC (&cmd);
	  }
	parle ("Merci pour tout ! ", NULL, NULL, "lettre1");
	change_obstacle (Map.stage, 0, avant,
			 get_obs (Map, Map.stage, 1, avant));
      }
      break;

    }
  load_all_screen_map ();
  AFFICHE_BLIT ();
}

/********************* init_scripts ***************/
void
init_scripts (void)
{
}


/************************ PORTE_SCENARIO **********************/

void PORTE_SCENARIO(){
		if(n_crystal == 2 && Map.prog == 3 && Map.stage == 39 ) { /* il ya quelque chose dans le village */
				Map.prog++;
				playmidi(AZZI_MIDI);
				FORCE_MIDI(AZZI_MIDI,4); /* forcer ce midi j'usqu'au stage 3*/
				parle("....quelque chose de mal est arrive au village","va vite voir !! c'est un  grand danger !",NULL,NULL);
		}
}


/****************************  PLACE_SCENARIO ***********/
void PLACE_SCENARIO(){
		if(Map.stage == 4 && n_crystal == 2 && Map.prog == 4){
				int i;
				affiche(buffer);
				playmidi(AZZI_MIDI);
				draw_sprite(buffer , Data[AZZI0].dat , 150 , 40);
				parle(pp.name , "AZZI ??? c'est toi ?",NULL,"azzi1");
				parle("AZZI : oui , c'est moi ! Mon pitit frere",NULL,NULL,"azzi2");
				parle(pp.name,"qu'est ce que tu veux encore ?",NULL,"azzi3");
				parle("AZZI : Donne moi tes bouts de crystaux","je vais me venger de tout le monde en exploitant la force","de ces crystaux ! ","azzi4");
				parle(pp.name,"reve ! j'en ai besoin pour guerir ma mere !",NULL,"azzi5");
				parle("AZZI : hinhinhin ! c'est moi qui ai maudit notre mere","je ne supporte plus personne maintenant",NULL,"azzi6");
				parle(pp.name,"t'es un malade ! grrr!",NULL,"azzi7");
				parle("AZZI : nous avons suffisament parle , passons aux actes","alors ... tu ne veux pas me donner les crystaux",NULL,"azzi8");
				for(i = 0 ; i < 10 ; i++){
						int x,y,K;
						srand(time(0));
						x=rand() % SCREEN_W;
						srand(time(0));
						y=rand() % SCREEN_H;
						explosion(x,y,40);
			   		    K = play_sfx (SFX4);
						while (voice_get_position (K) != -1);
				}
				parle("AZZI : Prepare toi a perir!","on va meme se teleporter dans un terrain de combat",NULL,"azzi9");
				Map.stage = 53;
				load_all_screen_map();
				AFFICHE_BLIT();
				playmidi(AZZI_BATTLE);
				BOSS = boss(Map.stage);
		}
}


/******************** DONNE_CRYSTAL **********************/
int DONNE_CRYSTAL(int boss){
		if(boss == 3) {
			Map.prog++;
			playmidi(MIDI10);
			parle("AZZI : tu m'as battu , ....","j'aurai ma vengence sur tout le monde , parce que ce n'est que le debut","je vais chercher les 7 autres bouts du crystal rouge","azzi10");
			parle("AZZI : qui se trouvent dans la face cachee de la terre","dans les profondeurs , appele 'MAGMA WORLD'","Au revoir ! Au VRAI revoir!","azzi11");
			affiche(buffer);
			parle(pp.name,".....la face cachee de la terre ,","y aurait-t-il une vie la dessous?...","azzi12");
			parle(pp.name,"maintenant , AZZI ne menace plus ma mere seulement","mais veut avoir le pouvoir de se venger sur tout le MONDE","azzi13");
			playmidi(MIDI11);
			FORCE_MIDI(MIDI11,60);
			parle(pp.name,"....je dois ramasser les bouts de cristaux ! allez on y va !",NULL,"azzi14");
			parle(pp.name,"c'est la seule chance de sauver ma mere!",NULL,"azzi15");
			parle(pp.name,".... je crois que mon pere m'appele ,il veut me dire quelque","chose!allons-y","azzi16");
			FADE(FADE_NORMAL);
			setpal;
			Map.stage = 0;
			pp.x = 20;
			pp.y = 40;
			load_all_screen_map();
			AFFICHE_BLIT();
			return 0;
		}
		return 1;
}

